<%--
Licensed Materials - Property of IBM
(c) Copyright IBM Corporation 2013. All Rights Reserved.
Note to U.S. Government Users Restricted Rights:  Use,
duplication or disclosure restricted by GSA ADP Schedule 
Contract with IBM Corp.
--%>
<%@page language="java"
	pageEncoding="UTF-8"
	contentType="application/atom+xml"
	import="java.util.List"
	import="com.ibm.team.dashboard.service.internal.markers.ViewHistoryService.HistoryFeed"
	import="com.ibm.team.dashboard.service.internal.markers.ViewHistoryService.HistoryEntry"
	import="com.ibm.team.jfs.app.xml.util.XmlUtil"
	import="net.jazz.ajax.internal.util.ServletUtil"
%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib prefix="dash" tagdir="/WEB-INF/tags/dashboard-internal"%>
<%
	HistoryFeed feed = (HistoryFeed)request.getAttribute(HistoryFeed.class.getName());
	pageContext.setAttribute("feed", feed);
	pageContext.setAttribute("self", ServletUtil.getRequestURLWithQuery(request));
	String updated = XmlUtil.xmlSafe(XmlUtil.toXmlString(new java.sql.Date(System.currentTimeMillis())));
%>
<?xml version="1.0" encoding="UTF-8"?>
<atom:feed xmlns:atom="http://www.w3.org/2005/Atom" xmlns:syndication="http://www.ibm.com/jazz/0.1.0/syndication">
	<atom:title>${fn:escapeXml(feed.title)}</atom:title>
	<atom:id>urn:uuid:<%=java.util.UUID.randomUUID()%></atom:id>
	<atom:updated><%=updated%></atom:updated>
	<atom:author>
		<atom:name>${fn:escapeXml(feed.author)}</atom:name>
	</atom:author>
	<atom:link rel="self" href="${fn:escapeXml(self)}" />
	<% for (HistoryEntry entry : feed.entries) { %>
	<atom:entry>
		<atom:title><%=XmlUtil.xmlSafe(entry.getLabel())%></atom:title>
		<atom:id>urn:uuid:<%=java.util.UUID.randomUUID()%></atom:id>
		<atom:updated><%=updated%></atom:updated>
		<atom:link rel="self" href="<%=XmlUtil.xmlSafe(entry.getURI())%>" />
		<atom:content atom:type="text" />
		<atom:category term="<%=XmlUtil.xmlSafe(entry.getType())%>" />
		<syndication:iconUri type="text"><%=XmlUtil.xmlSafe(entry.getIcon())%></syndication:iconUri>
		<syndication:application type="text"><%=XmlUtil.xmlSafe(entry.getApplication())%></syndication:application>
		<syndication:data type="text"><%=XmlUtil.xmlSafe(entry.getData())%></syndication:data>
		<syndication:project type="text"><%=XmlUtil.xmlSafe(entry.getProject())%></syndication:project>
		<atom:author>
			<atom:name><%=XmlUtil.xmlSafe(entry.getAuthor())%></atom:name>
			<atom:email><%=XmlUtil.xmlSafe(entry.getEmail())%></atom:email>
		</atom:author>
	</atom:entry>
	<% } %>
</atom:feed>