define(["require", "./_base/kernel"],
	function(require, dojo) {
		var SUFFIX = "." + djConfig.locale.replace(/-/, "_");
		dojo.i18n = {
			normalizeLocale: function(locale) {
				return locale ? locale.toLowerCase() : dojo.locale;
			},
			requireLocalization: function(){},
			getLocalization: function(pack, name) {
				return dojo.getObject(pack + ".nls." + name + SUFFIX)
					|| getAMDLocalization(pack, name);
			}
		};
		function getAMDLocalization(pack, name) {
			pack = pack.replace(/\./g, "/");
			var i = name.lastIndexOf('/') + 1;
			return require("dojo/i18n!" + pack + "/" + name.substring(0, i) + "nls/" + name.substring(i));
		}
		dojo.requireLocalization = dojo.i18n.requireLocalization;
		dojo.getLocalization = dojo.i18n.getLocalization;
		return {
			normalizeLocale: dojo.i18n.normalizeLocale,
			getLocalization: getAMDLocalization
		};
	}
);
