/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.adapter.internal.OpenSocialViewletAdapter");

dojo.require("jazz.util.internal.login");
dojo.require("jazz.client.xhr");

dojo.require("jazz.ui.FilterBox");
dojo.require("jazz.ui.HoverPopup");
dojo.require("jazz.ui.underlay");

dojo.require("com.ibm.team.dashboard.web.ui.internal.Constants");
dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");
dojo.require("com.ibm.team.dashboard.web.ui.internal.settings.ViewletSettingsPanel");
dojo.require("com.ibm.team.dashboard.web.ui.internal.settings.ScopePreferenceProvider");
dojo.require("com.ibm.team.dashboard.web.ui.internal.util.ServiceTracker");
dojo.require("com.ibm.team.dashboard.web.ui.internal.util.ItemNameRegistry");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.dashboard.web.client.internal.DashboardClient");
dojo.require("com.ibm.team.dashboard.web.adapter.internal.WindowlessDialog");

dojo.require("net.jazz.ajax.contextRoot");
dojo.require("net.jazz.ajax.dataServerRoot");
dojo.require("net.jazz.ajax.viewletWebUIRoot");

dojo.require("com.ibm.team.dashboard.web.adapter.internal.OpenSocialViewletSite");

dojo.require("net.jazz.ajax.ui.internal.OpenSocialJazz"); 

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

jazz.ui.HoverPopup.prototype.open = function() {
	// Override the hoverpopup to do nothing
};

(function() {
	
jazz.app.proxy.encodeProxiedURI = function(url) {
	if (url.indexOf("/") == 0) {
		return net.jazz.ajax.viewletWebUIRoot() + url;	
	}
	return url;	
};

var OpenSocialViewletSite = com.ibm.team.dashboard.web.adapter.internal.OpenSocialViewletSite;
var ScopePreferenceProvider = com.ibm.team.dashboard.web.ui.internal.settings.ScopePreferenceProvider;
var Constants = com.ibm.team.dashboard.web.ui.internal.Constants;
var ServiceTracker = com.ibm.team.dashboard.web.ui.internal.util.ServiceTracker;
var ItemNameRegistry = com.ibm.team.dashboard.web.ui.internal.util.ItemNameRegistry;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var DashboardClient = com.ibm.team.dashboard.web.client.internal.DashboardClient;
var TYPES = com.ibm.team.dashboard.web.ui.internal.settings.ViewletSettingsPanel.TYPES;

var messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

dojo.declare("com.ibm.team.dashboard.web.adapter.internal.OpenSocialViewletAdapter", [dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "adapter/internal/templates/OpenSocialViewletAdapter.html"),
	
	_messages: messages,
	
	postCreate: function() {
	
		//console.log("Quirks mode: " + document.compatMode);
	
		if ( !dojo.exists(net.jazz.ajax._ajaxModuleWidget) ) {
			console.log("Widget for viewlet not loaded: " + net.jazz.ajax._ajaxModuleWidget);
			return;
		}
		
		/* Override jazz.ui.Dialog. What is this madness!!!!???!
		 * The reason for doing this is that we want to prevent viewlets from opening Dialogs. Dialogs won't render
		 * correctly in the gadget iFrame so instead we need to hijack Dialog and embed the content node
		 */ 
		dojo.setObject("jazz.ui.Dialog", dojo.getObject("com.ibm.team.dashboard.web.adapter.internal.WindowlessDialog"));
		
		/* Override net.jazz.ajax.contextRoot and net.jazz.ajax.dataServerRoot with the version that is defined
		 * by the Gadget adapter*/		
		dojo.setObject("net.jazz.ajax.contextRoot", dojo.getObject("net.jazz.ajax.contextRoot.gadget"));
		dojo.setObject("net.jazz.ajax.dataServerRoot", dojo.getObject("net.jazz.ajax.dataServerRoot.gadget"));
		
		/* Register the body click listener so that we can listen for link clicks. If the user clicks on a 
		 * link, we need to open that link in a new window otherwise a page transition will occur in the small
		 * iframe.
		 */
		dojo.connect(dojo.body(), "onclick", this, "_handleBodyClick");
		
		// Create the viewlet site			
		var viewletSiteArgs = {
			actionArea: this.actionArea,
			adapter: this
		};
		this._viewletSite = new OpenSocialViewletSite(viewletSiteArgs);
		
		// Fetch scope item name
		var itemId = this._viewletSite.getPreference("_scopeItem");
		if (itemId) {
			var name = ItemNameRegistry.getName(itemId);
			if (!name) {
				// don't have it; fetch it
				var serviceObj = {
					_this: this,
					_itemId: itemId,
					success: function(/* string */ name) {
						// add to registry
						ItemNameRegistry.addName({itemId: this._itemId, name: name});
						this._this._loadViewlet();
					},
					failure: function(/* Error */ error) {
						// skip name and continue without it
						this._this._loadViewlet();
					}
				};
				var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
				var root = net.jazz.ajax.viewletWebUIRoot();
				DashboardClient.getItemName(this._viewletSite.getPreference("_scope"), itemId, root, srh, this._getServiceTracker());
			}
			else {
				this._loadViewlet();
			}
		}
		else {
			this._loadViewlet();
		}
	},
	
	_handleBodyClick: function(e) {
		var node = e.target;
		if (e.target) {
			if (node.tagName === "A") {
				if (node.href && node.href != "" && node.href != "javascript:void(0);"
					&& node.parentNode.id != "net-jazz-ajax-ui-internal-OpenSocialJazz-login") {
					// User click on a link which is page transition. Open this in a new tab
					dojo.stopEvent(e);
					window.open(node.href,'_blank');
				}
			}
		}
	},
	
	_loadViewlet: function() {
		// Create the viewlet
		var viewletConstructor = eval(net.jazz.ajax._ajaxModuleWidget);
		this._viewlet = new viewletConstructor({
			site : this._viewletSite,
			webURL: net.jazz.ajax.viewletWebUIRoot()
		});
		this._viewletSite.viewlet = this._viewlet;
		this._viewletSite.defaultState = this._viewlet.getDefaultState();
		
		/* Register the response interceptor
		 * Strategy - all oauth challenges are intercepted and handled by OpenSocialJazz.js 
		 * Here we simply want to register piggyback off the OpenSocialJazz response interceptor, and be notified
		 * whenever there is an OAuth failure.  Once detected, we'll destroy the viewlet. Once we detect the 
		 * login was successful, we will re-create the viewlet 
		 * 
		 * The problem with registering a response interceptor directly with jazz.client.xhr is that there 
		 * is no guarantee that our interceptor would be called. For example, if an interceptor vetos the response
		 * then its possible we won't get called here.  
		 *  
		 * We need to piggy back off the OpenSocialJazz response listener in this case because there is 
		 * no guarantee that a response */
		net.jazz.ajax.ui.internal.OpenSocialJazz._registerResponseListener(dojo.hitch(this, this._responseInterceptor));

		// Initalize viewlet settings
		this._canModifyViewlet = true;
		this._initSettings();
		this._workingCopy = this._getSettingsWorkingCopy();
		this.oldWorkingCopy = dojo.clone(this._workingCopy);
		
		// Initialize the viewlet
		this._viewlet.init();
		this._viewlet.refresh();
		
		this._bodyContainer.replaceChild(this._viewlet.domNode, this._loadingDiv);
		if (this._viewlet && this._fixUrls) {
			this._fixUrls(this._adapterContentArea);
		}			

		this._doResize();

// 		Debug code - prints out the views supported by the current container
//		console.warn("Current container supports the following views:");
//        var views = gadgets.views.getSupportedViews();
//        for (var view in views) {
//        	console.warn(view);	
//        }
	},
	
	/*
     * Interceptor method which listens for OAuth/Authentication failures. If we detect a failure, 
     * we need to destroy the viewlet and wait until we're notified of successful authentication 
	 *  
	 * @value response The response of a makeRequest call
 	 * 
 	 * @return void
 	 */	
	_responseInterceptor : function(response) {
		var oauthApprovalUrl = response.oauthApprovalUrl;
		
		if (oauthApprovalUrl && this._viewlet) {
			// Detected an OAuth failure so destroy the viewlet and remove all DOM content

			// Removing the editing area
			this._editButtonArea.style.display = "none";
			this._canModifyViewlet = true;
			
			// Removing all dialog content
			var dialogs = dojo.query(".com-ibm-team-dashboard-web-adapter-internal-WindowlessDialog");
	        dialogs.forEach(function(d) {
	        	document.body.removeChild(d);
	        },this);
			
			this._viewlet.destroy();
			delete viewlet;
			this._viewlet = null;			
			this._wasViewletDestroyed = true;
			
			while (this._bodyContainer.hasChildNodes()) {
			    this._bodyContainer.removeChild(this._bodyContainer.lastChild);
			}
		} else if (!oauthApprovalUrl && !this._viewlet && this._wasViewletDestroyed) {
			// Re-create the viewlet
			_wasViewletDestroyed = false;
			var viewletConstructor = eval(net.jazz.ajax._ajaxModuleWidget); 
			this._viewlet = new viewletConstructor({
				site: this._viewletSite,
				webURL: net.jazz.ajax.viewletWebUIRoot()
			});
			this._bodyContainer.appendChild(this._viewlet.domNode);
			this._viewlet.init();
			this._viewlet.refresh();
			if (this._viewlet) {
				this._fixUrls(this._adapterContentArea);
			}
		} 			
	},
	
	_showCanvasArea: function() {		
		if (this._viewletSite._isRefreshing) {
			delete this._refreshCheckTimer;
			this._refreshCheckTimer = setTimeout(dojo.hitch(this, this._showCanvasArea), 500);
		} else {
			this._handleSettings();
		}
	},
	
	_initSettings: function() {
		/* Check if the current viewlet has a preference type that is not
		 * supported by the opensocial container. If it does, we want to show
		 * the 'settings' icon so that the custom preferences can be embedded
		 * in the content area
		 */ 
		this._unsupportedPrefs = [];
		
		// Add the scope preference first (if needed) so that the 'scope' tab will appear first
		if (net.jazz.ajax._viewletDefinition.scopeSensitive) {
			this._unsupportedPrefs.push({
				"defaultValue": null,
				"id": "_scope",
				"preferenceType": "string",
				"required": true,
				"name": messages.scopePrefProvider
			});
		}
		var prefs = net.jazz.ajax._viewletDefinition.preferenceDefinitions;
		if (prefs) {
			for (var i = 0; i < prefs.length; i++) {
				var pref = prefs[i];
				if (pref.isSupportedPrefType === "true") {
					continue;
				}
				this._unsupportedPrefs.push(pref);
			}
		}
		
		this._deferredCustomPreferences = [];
		this._configureButtons();
	},
	
	_configureButtons: function() {
		var hasButtons = false;
		var root = net.jazz.ajax.viewletWebUIRoot();
		if (this._unsupportedPrefs.length > 0) {
			// add configure button
			var a = dojo.create("a", { href: "#", "class": "viewlet-btn" });
			var img = dojo.create("img", { src: root + "/web/com.ibm.team.dashboard.web/graphics/adapter/customize_view.gif"}, a);
			this._viewletBtns.appendChild(a);
			this.connect(a,"onclick",dojo.hitch(this,this._handleSettings));
			hasButtons = true;
		} 
		if (net.jazz.ajax._viewletDefinition.editable) {
			// add edit button
			a = dojo.create("a", { href: "#", "class": "viewlet-btn" });
			img = dojo.create("img", { src: root + "/web/com.ibm.team.dashboard.web/graphics/adapter/edit_contents.gif"}, a);
			this._viewletBtns.appendChild(a);			
			this.connect(a,"onclick",dojo.hitch(this,this.handleEditContent));
			hasButtons = true;
		}
		if (net.jazz.ajax._viewletDefinition.filterable) {
			// add the filter button
			a = dojo.create("a", { href: "#", "class": "viewlet-btn" });
			img = dojo.create("img", { src: root + "/web/com.ibm.team.dashboard.web/graphics/adapter/filter.gif"}, a);
			this._viewletBtns.appendChild(a);			
			this.connect(a,"onclick",dojo.hitch(this,this._doFilter));
			hasButtons = true;
		}
		
		if (hasButtons) {
			dojo.removeClass(this._viewletBtns, "hidden");
			this.connect(this.domNode,"onmouseover",dojo.hitch(this,this._showViewletMenuButtons,true));
			this.connect(this.domNode,"onmouseout",dojo.hitch(this,this._showViewletMenuButtons,false));
		}
	},
	
	_showViewletMenuButtons: function(show) {
		if (!this._canModifyViewlet) return;
		if (show) {
			dojo.removeClass(this._viewletBtns, "hidden");
		} else {
			dojo.addClass(this._viewletBtns, "hidden");
		}
	},
		
	_getServiceTracker: function() {
		if (!this._serviceTracker) {
			this._serviceTracker = new ServiceTracker();
		}
		return this._serviceTracker;
	},
	
	_getScopeLabel: function() {
		switch (net.jazz.ajax._viewletDefinition.appliesTo) {
			case Constants.SCOPE_APPLIES_TO_TEAMS:
				return messages.settingsScopeTeam;
			case Constants.SCOPE_APPLIES_TO_CONTRIBUTORS:
				return messages.settingsScopeUser;
			case Constants.SCOPE_APPLIES_TO_PROJECTS:
				return messages.settingsScopeProject;
			case Constants.SCOPE_APPLIES_TO_PROCESS:
				return messages.settingsScopeProcess;
			default:
				return messages.settingsScopeAll;
		}
	},
	
	_fixUrls: function (/* Element */ elem, /* Element */ parent) {
		parent = parent || elem.parentNode; 
		var attrs = elem.attributes;
		if (attrs) {
			var root = net.jazz.ajax.viewletWebUIRoot();
			var context = net.jazz.ajax.contextRoot();
			var host = root.substring(0, root.length - context.length);
			for (var i=0;i<attrs.length;++i) {
				var attr = attrs[i];
				if (attr.name == "href") {
					if (attr.nodeValue.indexOf("/") == 0) {
						var val = host + attr.nodeValue;
						//console.log(attr.nodeValue + " --- Setting to: " + val);
						attr.nodeValue = val; 
					}
				}
				if (attr.name == "src") {
					if (attr.nodeValue.indexOf("/") == 0) {
						var val = host + attr.nodeValue;
						//console.log(attr.nodeValue + " --- Setting to: " + val);
						attr.nodeValue = val;
					}
				}
				if (attr.name == "data") {
					// Flash element
					if (attr.nodeValue.indexOf("/") == 0) {
						var val = host + attr.nodeValue;
						//console.log(attr.nodeValue + " --- Setting to: " + val);
						attr.nodeValue = val;
					}
				}
			}
		}
		
		// recursively prune children
		var node = elem.firstChild;
		while (node) {
			node.nodeType === 1 && this._fixUrls(node, parent);
			node = node.nextSibling;
		}
	},
	
	/*==========================================================================*
	 *    Functions which handle the viewlet settings. We are required to adapt
	 *    Jazz preferences not supported by the OpenSocial spec (eg CUSTOM,
	 *    COMPUTED), and also handle any updates to those settings.
	 *    
	 *    The approach we're taking is to embed the non-supported preferences
	 *    into the content area of the Gadget.
	/*==========================================================================*/
	
	/*
	 * Handles a change to a viewlet settings. This should handle the result locally first
	 * and then notify the viewlet of the settings change so it can be handled there as well.
	 *  
 	 * @param id the id of the setting that was modified
 	 * @value value the new value for the setting
 	 * 
 	 * @return void
 	 */	
	_handleSettingsChange: function(value, id) {
		// N-1 compatibility; old scope pref provider still uses "scope"
		if (id == "_scope" || id == "scope") {
			if (value.itemId != this._workingCopy.scopeItemId) {
				this._workingCopy.scopeItemId = value.itemId;
				this._viewletSite.setPreference("_scopeItem", value.itemId);
				id = "scopeItem";
			}
			if (value.type != this._workingCopy.scope) {
				this._workingCopy.scope = value.type;
				this._viewletSite.setPreference("_scope", value.type);
				id = "scope";
			}
		} else if (id == "_scopeSubteams") {
			this._workingCopy.scopeSubteams = value;
			this._viewletSite.setPreference(id, value);
		} else {
			this._workingCopy.preferences[id] = value;
			this._viewletSite.setPreference(id, value);
		}
		
		this._viewlet.settingsChanged(this.oldWorkingCopy, this._workingCopy);
		this.oldWorkingCopy = dojo.clone(this._workingCopy);

		//gadgets.views.requestNavigateTo(new gadgets.views.View("home"));
		while (this.tabs.getTabs().length > 0) {
			this.tabs.removeTab(0);
		}
		dojo.removeClass(this._contentArea, "hidden");	
		this._canModifyViewlet = true;
	},
	
	
	/*
	 * 
 	 * @param void
 	 * 
 	 * @return void
 	 */	
	_handleSettingsCancel: function() {
		while (this.tabs.getTabs().length > 0) {
			this.tabs.removeTab(0);
		}
		this._canModifyViewlet = true;
		dojo.removeClass(this._contentArea, "hidden");
	},
	
	/*
	 * 
 	 * @param options
 	 * @param parent
 	 * @param value
 	 * 
 	 * @return void
 	 */		
	_populateComboOptions: function(options, parent, value) {
		for (var i = 0; i < options.length; i++) {
			var option = dojo.create("option",{value: options[i].value},parent);
			if (options[i].padding)
				option.style.paddingLeft = options[i].padding + "px";
			option.appendChild(document.createTextNode(options[i].label));
			if (value == options[i].value)
				option.selected = "selected";
		}
	},

	/* 
	 * Creates a selection combobox for a CUSTOM preference
	 * 
 	 * @param setting the preference object
 	 * 
 	 * @return A select list with the preference options already populated
 	 */	
	_createComputedInputField : function(setting) {
		var select = dojo.create("select",{name: setting.id, id: this.id + "-" + setting.id});
		if (setting.options)
			this._populateComboOptions(setting.options, select, setting.computedDefault ? setting.computedDefault : setting.value);
		else {
			for (var i = 0; i < setting.groups.length; i++) {
				if (setting.groups[i].name) {
					dojo.create("group", {label: setting.groups[i].name}, select);
					var group = document.createElement("optgroup");
					this._populateComboOptions(setting.groups[i].options, group, setting.value);
				} else
					this._populateComboOptions(setting.groups[i].options, select, setting.value);
			}
		}
		return select;
	},
	
	/*
	 * Handles CUSTOM preferences. Calls the viewlet to see if preference content is available.
	 *  
 	 * @param setting the preference object
 	 * @param onOk callback
 	 * 
 	 * @return A DOM node is content is available, null otherwise
 	 */	
	_handleCustomPreference: function(setting, onOk) {
		if (!this._viewlet) return null;
	
		// Call the viewlet to see if there if content is ready
		var result = this._viewlet.getPreferenceOptions(setting.id, this._workingCopy);
		if (result) {
			if (result.computedDefault)
				setting.value = result.computedDefault;
			if (result.options)
				setting.options = result.options;
			else if (result.groups)
				setting.groups = result.groups;
			var select = this._createComputedInputField(setting);
			
			/* If we already have a preference set for this select box then make sure
			 * it's selected when the content is loaded */
			var oldValue = this._viewletSite.getPreference(setting.id);
			for (var i = 0; i < setting.options.length; i++) {
				if (setting.options[i].value == oldValue) {
					select.selectedIndex = i; 
					break;
				}
			}
			
			var value = select.options[select.selectedIndex].value;
			if (value && value !== "") {
				this._workingCopy.preferences[setting.id] = value;
				setting.value = value;
			}
			
			var content = dojo.create("div", {"class" : "com-ibm-team-dashboard-web-adapter-internal-OpenSocialViewletAdapterPreferences"});
			content.appendChild(select);
			var controlsDiv = dojo.create("div", {"class" : "pref-button-site"}, content);
			var button = dojo.create("button", {id : "ok-btn-" + setting.id, "class" : "ok-button"}, controlsDiv);
			button.appendChild(document.createTextNode(messages.okBtn));

			//HACK ALERT
			button.preference = setting;
			button.selectBox = select;
			
			var cancel = dojo.create("button", {id : "cancel-btn-" + setting.id, "class" : "cancel-button"}, controlsDiv);
			cancel.appendChild(document.createTextNode(messages.cancelBtn));
			
			this.connect(button, "onclick", dojo.hitch(this, function(event){
				if (event.target.preference && event.target.selectBox) {
					onOk(event.target.selectBox.value, event.target.preference.id);
				}
			}));
			this.connect(cancel, "onclick", dojo.hitch(this, function(event){
				this._handleSettingsCancel();
			}));
			return content;
		} else {
			return null;
		}
	},
	
	_addTab: function(name, domNode) {
		var content = dojo.create("div", {"class" : "com-ibm-team-dashboard-web-adapter-internal-OpenSocialViewletAdapterSettingsArea"});
		content.appendChild(domNode);
		this.tabs.addTab(name, {
			contentContainer: content
		});	
		
	},
		
	/*
	 * Switches the gadget to 'Settings' mode and displays all non-OpenSocial friendly preferences.
	 * Jazz supports several preference types that OpenSocial does not, and so we need to embed  
	 * these settings in the Content area.
	 * 
 	 * @param void
 	 * 
 	 * @return void
 	 */	
	_handleSettings: function(e) {
		if (e) dojo.stopEvent(e);
		
		if (this._unsupportedPrefs.length == 0) {
			alert(messages.openSettingsManually);
			return;
		}
		
		/* Hide viewlet content and filter box*/
		dojo.addClass(this._contentArea, "hidden");
		if (this._isFiltering) {
			this._filterBox.clear();
			while (this._filterContainer.hasChildNodes()) {
				this._filterContainer.removeChild(this._filterContainer.lastChild);
			}
			this._isFiltering = false;
		}

		
		// Stop the resize timeout while we're modifying the DOM
		if (this._onResizeTimeout) {
			clearTimeout(this._onResizeTimeout);
			delete this._onResizeTimeout;
		}
		
		this._showViewletMenuButtons(false);
		this._canModifyViewlet = false;
		
		if (!this.tabs) {
			// Create the tabset 
			this.tabs = new gadgets.TabSet("configureTabSet", "settings");
			this.tabs.alignTabs("left");
		}
		for (var i = 0; i < this._unsupportedPrefs.length; i++) {
			if (this._unsupportedPrefs[i].preferenceType == "COMPUTED") {
				/* 
				 * The COMPUTED preference type is problematic because it's dynamic. We need to 
				 * keep track of whether or not there is content, and if there isn't content, automatically
				 * update the UI when the content is 'computed'
				 */
				var content = this._handleCustomPreference(this._unsupportedPrefs[i], dojo.hitch(this, this._handleSettingsChange));
				if (content) {
					// Content is available, so we can just add it
					this._fixUrls(content);
					this._addTab(this._unsupportedPrefs[i].name, content);
				} else {
					/* The content for this tab is not yet available - typically this occurs when the framework
					 * needs to make a request to determine the what gets returned (eg Work Items Statistics viewlet - 
					 * the 'Parameter' field is dynamically fetched and won't be available right away.)
					 * 
					 * In this case, just add a 'loading' message to the UI and we'll automatically  
					 * */
					var inputDiv = dojo.create("div", null);
					inputDiv.appendChild(document.createTextNode(messages.settingsLoadingOpts));
					this._addTab(this._unsupportedPrefs[i].name, inputDiv);
					
					/* Add the current preference to a "deferred" list - when all the preferences have been added,
					 * we'll check to see if there is content again. */ 
					this._deferredCustomPreferences.push(this._unsupportedPrefs[i]);
				}
			} else {
				if (this._unsupportedPrefs[i].id == "_scope") {
					/* Use the internal ScopePrefrenceProvider for scope settings */
					var prefProvider = new ScopePreferenceProvider({
						appliesTo: net.jazz.ajax._viewletDefinition.appliesTo,
						preferenceId: "_scope"
					});
				} else {
					/* This is the 'normal' case where the preference has a preference provider */
					prefProvider = this._viewlet.getPreferenceProvider(this._unsupportedPrefs[i].id);
				}
				if (!prefProvider.createDOMChooser) {
					console.warn("Cannot add custom preference provider: " + this._unsupportedPrefs[i].id 
							+ " (" + this._unsupportedPrefs[i].name + ") - Adoption required");
				}
				prefProvider.settings = this._workingCopy;
				var panelContent = prefProvider.createDOMChooser(dojo.hitch(this, this._handleSettingsChange), 
						this._workingCopy, 
						this._viewlet,
						dojo.hitch(this, this._handleSettingsCancel));
				if (panelContent) {
					this._fixUrls(panelContent);
					this._addTab(this._unsupportedPrefs[i].name, panelContent);					
				} else {
					console.warn("Cannot add custom preference provider: " + this._unsupportedPrefs[i].id 
							+ " (" + this._unsupportedPrefs[i].name + ")");
				}
			}			
		} 
		
		this._doResize();
		
		if (this.tabs) {
			dojo.addClass(this._contentArea, "hidden");
			this.tabs.displayTabs(true);
			this.tabs.setSelectedTab(0);
		}
		
		/* If we have a custom preference awaiting content, start checking to see if the result has returned. */
		if (this._deferredCustomPreferences.length > 0) {
			this._processDeferredCustomPreferences();
		}

	},

	/*
	 * Processes any deferred custom preferences. Sets a timer and periodically checks for
	 * content until it is retrieved.  
	 * 
 	 * @param void
 	 * 
 	 * @return void
 	 */	
	_processDeferredCustomPreferences: function() {
		if (!this.tabs || this.tabs.getTabs().length == 0) return;
		
		if (this._deferredCustomPrefTimeout) {
			delete this._deferredCustomPrefTimeout;
		}
		
		for (var i = 0; i < this._deferredCustomPreferences.length; i++) {
			// Cycle through each of the deferred preferences and check if the content is ready
			var content = this._handleCustomPreference(this._deferredCustomPreferences[i], dojo.hitch(this, this._handleSettingsChange));
			if (content) {
				// We have content
				
				// Find the correct tab for the current preference
				var name = this._deferredCustomPreferences[i].name;
				var tabSet = this.tabs.getTabs();
				var preferenceTab = null;
				for (var j = 0; j < tabSet.length; j++) {
					var tab = tabSet[j];
					if (name == tab.getName()) {
						preferenceTab = tab;
						break;
					}
				}
				
				// Get the DOM Element and replace the content 
				var tabDom = preferenceTab.getContentContainer();
				while (tabDom.childNodes.length > 0) {
					// Remove the existing children from the tab
					tabDom.removeChild(tabDom.childNodes[0]); 
				}
				tabDom.appendChild(content);
				
				this._deferredCustomPreferences.splice(i, 1);
				i--; 
			}
		}

		// If there are still preferences in the deferred list, start a timer and try again
		if (this._deferredCustomPreferences.length > 0) {
			this._deferredCustomPrefTimeout = setTimeout(dojo.hitch(this, this._processDeferredCustomPreferences), 500);
		}
	},
	
	_getSettingsWorkingCopy: function() {
		var workingCopy = { title: this._viewletSite.getTitle() };
		if (net.jazz.ajax._viewletDefinition.scopeSensitive) {
			var scopeItemId = this._viewlet.getScopeItem() ? this._viewlet.getScopeItem().itemId : null;
			workingCopy.scope = net.jazz.ajax._viewletDefinition.appliesTo;
			workingCopy.scopeItemId = scopeItemId;
			if (net.jazz.ajax._viewletDefinition.scopeSubteams == "yes"
					|| net.jazz.ajax._viewletDefinition.scopeSubteams == "yes-and-check") {
				var scopeSubteams = this._viewlet.getScopeSubteams();
				workingCopy.scopeSubteams = scopeSubteams;
			}
		}
		var prefs = net.jazz.ajax._viewletDefinition.preferenceDefinitions;
		if (prefs && prefs.length > 0) {
			workingCopy.preferences = {};
			for (var i = 0; i < prefs.length; i++) {
				workingCopy.preferences[prefs[i].id] = this._viewletSite.getPreference(prefs[i].id);
			}
		}
		return workingCopy;
	},
	
	/*==========================================================================*
	 *            Helper methods to start filtering viewlet content  		
	 *             Note that these methods are only applicable to 	 
	 *                  viewlets declared as 'filterable'  
	/*==========================================================================*/
	
	_doFilter: function(e) {
		if (e) dojo.stopEvent(e);
		if (this._isFiltering) {
			this._filterBox.clear();
			while (this._filterContainer.hasChildNodes()) {
				this._filterContainer.removeChild(this._filterContainer.lastChild);
			}
			this._isFiltering = false;
		} else {
			this._filterContainer.appendChild(this._filterBox.domNode);
			this._isFiltering = true;
		}
		
	},
	
	/*
	 * Returns a FilterBox for the viewlet
 	 * @param void
 	 * 
 	 * @return an instance of jazz.ui.Filterbox
 	 */	
	getFilterBox: function() {
		if (!this._filterBox) {
			this._filterBox = new jazz.ui.FilterBox({
				dwellTime: 300
			});
		}
		return this._filterBox;
	},
	
	/*==========================================================================*
	 *              Helper methods to start editing viewlet content  		
	 *   Note that these methods are only applicable to viewlets declared as
	 *             'editable' (ie viewlets which editable content) 
	/*==========================================================================*/
	
	handleEditContent: function(event) {
		if (!this._viewlet.isEditing()) {
			this._showViewletMenuButtons(false);
			this._canModifyViewlet = false;
			this._startEditing(event);
		}
	},

	/*
	 * Handles the request to start editing the viewlet content
 	 * @param void
 	 * 
 	 * @return void
 	 */		
	_startEditing: function(e) {
		if (e) { dojo.stopEvent(e); }
		this._viewletSite.setAutoRefresh(false);
		
		// show button panel
		this._editButtonArea.style.display = "block";
		this.editingButtons = [];
		this.editingButtons.push(this.connect(this._saveEdits, "onclick", this._stopEditing));
		this.editingButtons.push(this.connect(this._cancelEdits, "onclick", this._stopEditing));
		
		// switch to edit mode
		this._viewlet.getViewletState().startEditing();
		this._viewlet.setEditing(true);
	},
	
	/*
	 * Handles a request to stop editing the viewlet content.
 	 * @param onclick event
 	 * 
 	 * @return void
 	 */			
	_stopEditing: function(e) {
		if (e) { dojo.stopEvent(e);	}
		// collapsing viewlet while in edit mode calls this method
		var saving = e.target == this._saveEdits;
		if (saving) {
			// "OK" button was clicked
			// validate edited content
			var validContent = this._viewlet.validateEditedContent();
			// check if the content is valid
			if (validContent == false) {
				// Content is not valid.  Stay in edit mode
				return;
			}
			// content is valid. leave edit mode
			// notify viewlet that edited contents is about to be saved
			this._viewlet.preSaveState();
		}

		// hide button panel
		this._editButtonArea.style.display = "none";
		while(this.editingButtons.length > 0) {
			this.disconnect(this.editingButtons.pop());
		}
		
		// switch out of edit mode
		this._viewlet.getViewletState().stopEditing(saving);
		this._viewlet.setEditing(false);
		this._viewletSite.setAutoRefresh(true);
		
		this._canModifyViewlet = true;
	},

	/*==========================================================================*
	 *              Helper methods to resize the iFrame of the gadget           *
	/*==========================================================================*/
	
	/*
	 * Adjust the height of the gadget. This function sets a polling timer to check
	 * and responds to changes in the content size.  
 	 * @param void
 	 * 
 	 * @return void
 	 */		
	_doResize: function() {
		if (this._isDestroyed || !this.domNode) return;
		
		// Piggyback off the resize timer and fix the URLs while we can
		this._fixUrls(this._adapterContentArea);
		
		if (dojo.body()) {
			var dialogs = dojo.query("[id^='com_ibm_team_dashboard_web_adapter_internal_WindowlessDialog']");
			var height = 0;
			if (dialogs.length > 0) {
				height = dojo.marginBox(dialogs.pop()).h;
			} else {
				height = dojo.marginBox(dojo.body()).h;
			}

			if (isNaN(height) || (height <= 0)) {
				gadgets.window.adjustHeight();
			} else {
				gadgets.window.adjustHeight(height);
			}
		}
		
		clearTimeout(this._onResizeTimeout);
		this._onResizeTimeout = setTimeout(dojo.hitch(this, this._doResize), 500);
	},
	
	
	/*
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */		
	destroy: function() {
		
		if (this._viewlet) {
			this._viewlet.destroy();
			this._viewlet = null;
		}
		
		if (this._onResizeTimeout) {
			clearTimeout(this._onResizeTimeout);
			delete this._onResizeTimeout;
		}
		
		if (this._deferredCustomPrefTimeout) {
			clearTimeout(this._deferredCustomPrefTimeout);
			delete this._deferredCustomPrefTimeout;
		}
		
		if (this._refreshCheckTimer) {
			clearTimeout(this._refreshCheckTimer);
			delete this._refreshCheckTimer;
		}
		
		this.inherited(arguments);
	}	
	
});

})();