/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.client.internal.AccessGroupClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceRequest"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.TeamServerClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.accessgroup.AccessGroup"); //$NON-NLS-1$
	
	// constants and aliases
	var SERVICE_URI = "com.ibm.team.process.internal.service.web.IProcessWebUIService"; //$NON-NLS-1$
	var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
	var AccessGroupClient = com.ibm.team.process.web.client.internal.AccessGroupClient;
	
	function getAccessGroupsPaged(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getAccessGroupsPaged", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	AccessGroupClient.getAccessGroupsPaged = getAccessGroupsPaged;
	
	function getAvailableAccessGroups(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getAvailableAccessGroups", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	AccessGroupClient.getAvailableAccessGroups = getAvailableAccessGroups;

	function postAccessGroup(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postAccessGroup", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	AccessGroupClient.postAccessGroup = postAccessGroup;
	
	function postArchiveAccessGroup(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postArchiveAccessGroup", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	AccessGroupClient.postArchiveAccessGroup = postArchiveAccessGroup;

	function postRestoreAccessGroup(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postRestoreAccessGroup", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	AccessGroupClient.postRestoreAccessGroup = postRestoreAccessGroup;
	
	function getAccessGroupByUUID(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getAccessGroupByUUID", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	AccessGroupClient.getAccessGroupByUUID = getAccessGroupByUUID;
	
	function convertFromAccessGroupDTOToAccessGroup (accessGroupDTO) {
		var accessGroup = new com.ibm.team.process.web.ui.accessgroup.AccessGroup();
		accessGroup.itemId = accessGroupDTO.itemId;
		accessGroup.stateId = accessGroupDTO.stateId;
		accessGroup.contextId = accessGroupDTO.contextId;
		accessGroup.name = accessGroupDTO.name;
		accessGroup.description = accessGroupDTO.description;
		accessGroup.archived = accessGroupDTO.archived;
		accessGroup.members = [];
		dojo.forEach(accessGroupDTO.members, function(accessGroupDTOMember) {
			var member = new com.ibm.team.process.web.ui.accessgroup.AccessGroupMember();
			member.itemId = accessGroupDTOMember.itemId;
			member.name = accessGroupDTOMember.name;
			member.type = accessGroupDTOMember.type;
			member.contextType = accessGroupDTOMember.contextType;
			accessGroup.members.push(member);
		});
		return accessGroup;
	}
	
	AccessGroupClient.convertFromAccessGroupDTOToAccessGroup = convertFromAccessGroupDTOToAccessGroup;
		 
})();
