/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.common.internal.Attachment"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	dojo.declare("com.ibm.team.process.authoring.web.common.common.internal.Attachment", null, { //$NON-NLS-1$
		url: null,
		path: "", //$NON-NLS-1$
		creationDate: "", //$NON-NLS-1$
		size: "", //$NON-NLS-1$
		creatorUrl: null,
		service: "",  //$NON-NLS-1$ //
		contentUrl: null,
		ownerUrl: null,
		otherProperties: null, // map of name to XML element
				
		constructor: function(xmlElement) {
			this.url = UIHelper.getAttributeNode(xmlElement, ProcessAuthoringConstants.XMLATTRIBUTE_ABOUT, ProcessAuthoringConstants.NAMESPACE_RDF).value;
			this.otherProperties = {};
			dojo.some(xmlElement.childNodes, function(node) {
				return this.parseNode(node);
			}, this);
		},
		
		parseNode: function(node) {
			if (!this.path && UIHelper.isSpecifiedNode(node, ProcessAuthoringConstants.XMLELEMENT_PATH, ProcessAuthoringConstants.NAMESPACE_JTP)) {
				if (node.firstChild) {
					this.path = UIHelper.unescapeXML(node.firstChild.data);
				}
			} else if (!this.creationDate && UIHelper.isSpecifiedNode(node, ProcessAuthoringConstants.XMLELEMENT_CREATED_DATE, ProcessAuthoringConstants.NAMESPACE_DC)) {
				if (node.firstChild) {
					this.creationDate = UIHelper.unescapeXML(node.firstChild.data);
				}
			} else if (!this.size && UIHelper.isSpecifiedNode(node, ProcessAuthoringConstants.XMLELEMENT_SIZE, ProcessAuthoringConstants.NAMESPACE_JTP)) {
				if (node.firstChild) {
					this.size = UIHelper.unescapeXML(node.firstChild.data);
				}
			} else if (!this.creatorUrl && UIHelper.isSpecifiedNode(node, ProcessAuthoringConstants.XMLELEMENT_CREATOR, ProcessAuthoringConstants.NAMESPACE_DC)) {
				this.creatorUrl = UIHelper.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
				this.creatorUrl = decodeURI(this.creatorUrl);
			} else if (!this.service && UIHelper.isSpecifiedNode(node, ProcessAuthoringConstants.XMLELEMENT_SERVICE, ProcessAuthoringConstants.NAMESPACE_JTP)) {
				if (node.firstChild) {
					this.service = UIHelper.unescapeXML(node.firstChild.data);
				}
			} else if (!this.contentUrl && UIHelper.isSpecifiedNode(node, ProcessAuthoringConstants.XMLELEMENT_CONTENT, ProcessAuthoringConstants.NAMESPACE_JTP)) {
				this.contentUrl = UIHelper.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
			} else if (!this.ownerUrl && UIHelper.isSpecifiedNode(node, ProcessAuthoringConstants.XMLELEMENT_OWNER, ProcessAuthoringConstants.NAMESPACE_JTP)) {
				this.ownerUrl = UIHelper.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
			} else if (node.nodeType == ProcessAuthoringConstants.NodeType.ELEMENT) {
				this.otherProperties[node.tagName] = node;
			}
			return this.doneInitialization();
		},
		
		doneInitialization: function() {
			return false;
		}
		
	});
})();
