
CREATE TABLE $(CALM_SCHEMA).RQRMENT_DATE_EXT (
		REQUIREMENT_ID INT  DEFAULT -1 NOT NULL,
		REQUIREMENT_ATTRDEF_ID INT DEFAULT -1 NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL,
		VAL DATE
)  ON VNF_32K 
GO

CREATE INDEX RQRDTEXT_IDX1 ON $(CALM_SCHEMA).RQRMENT_DATE_EXT (REQUIREMENT_ID ASC, REQUIREMENT_ATTRDEF_ID ASC) ON VNF_IDX
GO

CREATE INDEX RQRDTEXT_IDX2 ON $(CALM_SCHEMA).RQRMENT_DATE_EXT (REQUIREMENT_ID ASC, REQUIREMENT_ATTRDEF_ID ASC, VAL ASC) ON VNF_IDX
GO

ALTER TABLE $(CALM_SCHEMA).RQRMENT_DATE_EXT ADD CONSTRAINT RQRDTEXT_FK1 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES $(NF_SCHEMA).REQUIREMENT (REQUIREMENT_ID)
GO
	
ALTER TABLE $(CALM_SCHEMA).RQRMENT_DATE_EXT ADD CONSTRAINT RQRDTEXT_FK2 FOREIGN KEY (REQUIREMENT_ATTRDEF_ID)
	REFERENCES $(CALM_SCHEMA).RQRMENT_ATTRDEF (REQUIREMENT_ATTRDEF_ID)
GO

CREATE VIEW $(CALM_SCHEMA).VW_RQRMENT_DATE_EXT (REQUIREMENT_ID, NAME, IDENTIFIER, DATATYPE, TYPE_NAME, TYPE_IDENTIFIER, ISSOFTDELETED, VAL) AS
(SELECT E.REQUIREMENT_ID, A.NAME, A.IDENTIFIER, A.DATATYPE, T.NAME AS TYPENAME, T.IDENTIFIER AS TYPE_IDENTIFIER, E.ISSOFTDELETED, E.VAL 
  FROM $(CALM_SCHEMA).RQRMENT_DATE_EXT E 
  JOIN $(CALM_SCHEMA).RQRMENT_ATTRDEF A ON A.REQUIREMENT_ATTRDEF_ID=E.REQUIREMENT_ATTRDEF_ID 
  JOIN $(CALM_SCHEMA).RQRMENT_TYPE T ON T.REQUIREMENT_TYPE_ID=A.REQUIREMENT_TYPE_ID)
GO

GRANT SELECT ON $(CALM_SCHEMA).VW_RQRMENT_DATE_EXT TO $(REP_USER)
GO

CREATE TRIGGER TRG_RQRATTRS 
	ON $(NF_SCHEMA).REQUIREMENT 
	
	FOR UPDATE 
AS 
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 
	DELETE FROM $(CALM_SCHEMA).RQRMENT_BOOL_EXT 	WHERE REQUIREMENT_ID IN (SELECT REQUIREMENT_ID FROM INSERTED)
	DELETE FROM $(CALM_SCHEMA).RQRMENT_DATE_EXT 	WHERE REQUIREMENT_ID IN (SELECT REQUIREMENT_ID FROM INSERTED)
	DELETE FROM $(CALM_SCHEMA).RQRMENT_DECIMAL_EXT 	WHERE REQUIREMENT_ID IN (SELECT REQUIREMENT_ID FROM INSERTED) 
	DELETE FROM $(CALM_SCHEMA).RQRMENT_INT_EXT 		WHERE REQUIREMENT_ID IN (SELECT REQUIREMENT_ID FROM INSERTED)
	DELETE FROM $(CALM_SCHEMA).RQRMENT_STRING_EXT 	WHERE REQUIREMENT_ID IN (SELECT REQUIREMENT_ID FROM INSERTED)
	DELETE FROM $(CALM_SCHEMA).RQRMENT_STRING_L_EXT WHERE REQUIREMENT_ID IN (SELECT REQUIREMENT_ID FROM INSERTED)
	DELETE FROM $(CALM_SCHEMA).RQRMENT_TIMESTAMP_EXT WHERE REQUIREMENT_ID IN (SELECT REQUIREMENT_ID FROM INSERTED)
END
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=29, CHAR_VALUE='4.0.3 RC1' WHERE INFO_ID=17
GO