DROP TRIGGER RICALM.TRG_KWSCRD
GO

CREATE TRIGGER TRG_KWSCRD
    ON RICALM.KEYWORD

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  DELETE FROM RICALM.KEYWORD_SCRIPT_LOOKUP  WHERE  KEYWORD_ID IN 
  (SELECT  KEYWORD_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TPOBJSTAD
GO

CREATE TRIGGER TRG_TPOBJSTAD
    ON RIODS.TESTPLAN

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTPLAN_OBJECTIVESTATUS SET ISSOFTDELETED=1 WHERE  TESTPLAN_ID IN 
  (SELECT  TESTPLAN_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TPOBJD
GO

CREATE TRIGGER TRG_TPOBJD
    ON RIODS.TESTPLAN

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  DELETE FROM RICALM.TESTPLAN_OBJECTIVE_LOOKUP  WHERE  TESTPLAN_ID IN 
  (SELECT  TESTPLAN_ID FROM INSERTED )
 END
GO

DROP TRIGGER RICALM.TRG_REQCSD
GO

CREATE TRIGGER TRG_REQCSD
    ON RICALM.LABREQUEST

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  DELETE FROM RICALM.LABREQUEST_CHANGESTATE  WHERE  LABREQUEST_ID IN 
  (SELECT  LABREQUEST_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_RESVREQD
GO

CREATE TRIGGER TRG_RESVREQD
    ON RIODS.RESERVATION

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  DELETE FROM RICALM.RESERVATION_LABREQUEST_LOOKUP  WHERE  RESERVATION_ID IN 
  (SELECT  RESERVATION_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TPSTREXTD
GO

CREATE TRIGGER TRG_TPSTREXTD
    ON RIODS.TESTPLAN

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTPLAN_STRING_EXT SET ISSOFTDELETED=1 WHERE  TESTPLAN_ID IN 
  (SELECT  TESTPLAN_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TPSTRMEXTD
GO

CREATE TRIGGER TRG_TPSTRMEXTD
    ON RIODS.TESTPLAN

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTPLAN_STRING_M_EXT SET ISSOFTDELETED=1 WHERE  TESTPLAN_ID IN 
  (SELECT  TESTPLAN_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TPINTEXTD
GO

CREATE TRIGGER TRG_TPINTEXTD
    ON RIODS.TESTPLAN

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTPLAN_INT_EXT SET ISSOFTDELETED=1 WHERE  TESTPLAN_ID IN 
  (SELECT  TESTPLAN_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TPTIMEEXTD
GO

CREATE TRIGGER TRG_TPTIMEEXTD
    ON RIODS.TESTPLAN

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTPLAN_TIMESTAMP_EXT SET ISSOFTDELETED=1 WHERE  TESTPLAN_ID IN 
  (SELECT  TESTPLAN_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TCSTREXTD
GO

CREATE TRIGGER TRG_TCSTREXTD
    ON RIODS.TESTCASE

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTCASE_STRING_EXT SET ISSOFTDELETED=1 WHERE  TESTCASE_ID IN 
  (SELECT  TESTCASE_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TCSTRMEXTD
GO

CREATE TRIGGER TRG_TCSTRMEXTD
    ON RIODS.TESTCASE

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTCASE_STRING_M_EXT SET ISSOFTDELETED=1 WHERE  TESTCASE_ID IN 
  (SELECT  TESTCASE_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TCINTEXTD
GO

CREATE TRIGGER TRG_TCINTEXTD
    ON RIODS.TESTCASE

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTCASE_INT_EXT SET ISSOFTDELETED=1 WHERE  TESTCASE_ID IN 
  (SELECT  TESTCASE_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TCTIMEEXTD
GO

CREATE TRIGGER TRG_TCTIMEEXTD
    ON RIODS.TESTCASE

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTCASE_TIMESTAMP_EXT SET ISSOFTDELETED=1 WHERE  TESTCASE_ID IN 
  (SELECT  TESTCASE_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSCSTREXTD
GO

CREATE TRIGGER TRG_TSCSTREXTD
    ON RIODS.TESTSCRIPT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSCRIPT_STRING_EXT SET ISSOFTDELETED=1 WHERE  TESTSCRIPT_ID IN 
  (SELECT  TESTSCRIPT_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSCSTRMEXTD
GO

CREATE TRIGGER TRG_TSCSTRMEXTD
    ON RIODS.TESTSCRIPT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSCRIPT_STRING_M_EXT SET ISSOFTDELETED=1 WHERE  TESTSCRIPT_ID IN 
  (SELECT  TESTSCRIPT_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSCINTEXTD
GO

CREATE TRIGGER TRG_TSCINTEXTD
    ON RIODS.TESTSCRIPT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSCRIPT_INT_EXT SET ISSOFTDELETED=1 WHERE  TESTSCRIPT_ID IN 
  (SELECT  TESTSCRIPT_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSCTIMEEXTD
GO

CREATE TRIGGER TRG_TSCTIMEEXTD
    ON RIODS.TESTSCRIPT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSCRIPT_TIMESTAMP_EXT SET ISSOFTDELETED=1 WHERE  TESTSCRIPT_ID IN 
  (SELECT  TESTSCRIPT_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSUSTREXTD
GO

CREATE TRIGGER TRG_TSUSTREXTD
    ON RIODS.TESTSUITE

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSUITE_STRING_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITE_ID IN 
  (SELECT  TESTSUITE_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSUSTRMEXTD
GO

CREATE TRIGGER TRG_TSUSTRMEXTD
    ON RIODS.TESTSUITE

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSUITE_STRING_M_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITE_ID IN 
  (SELECT  TESTSUITE_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSUINTEXTD
GO

CREATE TRIGGER TRG_TSUINTEXTD
    ON RIODS.TESTSUITE

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSUITE_INT_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITE_ID IN 
  (SELECT  TESTSUITE_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSUTIMEEXTD
GO

CREATE TRIGGER TRG_TSUTIMEEXTD
    ON RIODS.TESTSUITE

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSUITE_TIMESTAMP_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITE_ID IN 
  (SELECT  TESTSUITE_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_EWISTREXTD
GO

CREATE TRIGGER TRG_EWISTREXTD
    ON RIODS.EXECUTION_WORKITEM

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.EXECWORKITEM_STRING_EXT SET ISSOFTDELETED=1 WHERE  EXECWORKITEM_ID IN 
  (SELECT  EXECWORKITEM_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_EWISTRMEXTD
GO

CREATE TRIGGER TRG_EWISTRMEXTD
    ON RIODS.EXECUTION_WORKITEM

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.EXECWORKITEM_STRING_M_EXT SET ISSOFTDELETED=1 WHERE  EXECWORKITEM_ID IN 
  (SELECT  EXECWORKITEM_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_EWIINTEXTD
GO

CREATE TRIGGER TRG_EWIINTEXTD
    ON RIODS.EXECUTION_WORKITEM

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.EXECWORKITEM_INT_EXT SET ISSOFTDELETED=1 WHERE  EXECWORKITEM_ID IN 
  (SELECT  EXECWORKITEM_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_EWITIMEEXTD
GO

CREATE TRIGGER TRG_EWITIMEEXTD
    ON RIODS.EXECUTION_WORKITEM

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.EXECWORKITEM_TIMESTAMP_EXT SET ISSOFTDELETED=1 WHERE  EXECWORKITEM_ID IN 
  (SELECT  EXECWORKITEM_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSERSTREXTD
GO

CREATE TRIGGER TRG_TSERSTREXTD
    ON RIODS.TESTSUITE_EXECUTION_RECORD

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TSTSUITEXECREC_STRING_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITE_EXECRECORD_ID IN 
  (SELECT  TESTSUITE_EXECRECORD_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSERSTRMEXTD
GO

CREATE TRIGGER TRG_TSERSTRMEXTD
    ON RIODS.TESTSUITE_EXECUTION_RECORD

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TSTSUITEXECREC_STRING_M_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITE_EXECRECORD_ID IN 
  (SELECT  TESTSUITE_EXECRECORD_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSERINTEXTD
GO

CREATE TRIGGER TRG_TSERINTEXTD
    ON RIODS.TESTSUITE_EXECUTION_RECORD

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TSTSUITEXECREC_INT_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITE_EXECRECORD_ID IN 
  (SELECT  TESTSUITE_EXECRECORD_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSERTIMEEXTD
GO

CREATE TRIGGER TRG_TSERTIMEEXTD
    ON RIODS.TESTSUITE_EXECUTION_RECORD

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TSTSUITEXECREC_TIMESTAMP_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITE_EXECRECORD_ID IN 
  (SELECT  TESTSUITE_EXECRECORD_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_EXCRESSTREXTD
GO

CREATE TRIGGER TRG_EXCRESSTREXTD
    ON RIODS.EXECUTION_RESULT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.EXECRES_STRING_EXT SET ISSOFTDELETED=1 WHERE  EXECUTION_RESULT_ID IN 
  (SELECT  EXECUTION_RESULT_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_EXCRESSTRMEXTD
GO

CREATE TRIGGER TRG_EXCRESSTRMEXTD
    ON RIODS.EXECUTION_RESULT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.EXECRES_STRING_M_EXT SET ISSOFTDELETED=1 WHERE  EXECUTION_RESULT_ID IN 
  (SELECT  EXECUTION_RESULT_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_EXCRESINTEXTD
GO

CREATE TRIGGER TRG_EXCRESINTEXTD
    ON RIODS.EXECUTION_RESULT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.EXECRES_INT_EXT SET ISSOFTDELETED=1 WHERE  EXECUTION_RESULT_ID IN 
  (SELECT  EXECUTION_RESULT_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_EXCRESTIMEEXTD
GO

CREATE TRIGGER TRG_EXCRESTIMEEXTD
    ON RIODS.EXECUTION_RESULT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.EXECRES_TIMESTAMP_EXT SET ISSOFTDELETED=1 WHERE  EXECUTION_RESULT_ID IN 
  (SELECT  EXECUTION_RESULT_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSULOGSTREXTD
GO

CREATE TRIGGER TRG_TSULOGSTREXTD
    ON RIODS.TESTSUITELOG

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSUITELOG_STRING_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITELOG_ID IN 
  (SELECT  TESTSUITELOG_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSULOGSTRMEXTD
GO

CREATE TRIGGER TRG_TSULOGSTRMEXTD
    ON RIODS.TESTSUITELOG

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSUITELOG_STRING_M_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITELOG_ID IN 
  (SELECT  TESTSUITELOG_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSULOGINTEXTD
GO

CREATE TRIGGER TRG_TSULOGINTEXTD
    ON RIODS.TESTSUITELOG

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSUITELOG_INT_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITELOG_ID IN 
  (SELECT  TESTSUITELOG_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_TSULOGTIMEEXTD
GO

CREATE TRIGGER TRG_TSULOGTIMEEXTD
    ON RIODS.TESTSUITELOG

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 

  UPDATE RICALM.TESTSUITELOG_TIMESTAMP_EXT SET ISSOFTDELETED=1 WHERE  TESTSUITELOG_ID IN 
  (SELECT  TESTSUITELOG_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_ITERDETD
GO

CREATE TRIGGER TRG_ITERDETD
    ON RIODS.ITERATION

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 
	
  UPDATE RICALM.ITERATION_EXEC_DETAIL SET ISSOFTDELETED=1 WHERE  ITERATION_ID IN 
  (SELECT  ITERATION_ID FROM INSERTED )
 END
GO

DROP TRIGGER RIODS.TRG_REQUIATTRD
GO

CREATE TRIGGER TRG_REQUIATTRD 
	ON RIODS.REQUIREMENT 
	
	FOR UPDATE 
AS 
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN 
	
	DELETE FROM RICALM.RQRMENT_ENUMERATION  WHERE  REQUIREMENT_ID IN 
	(SELECT  REQUIREMENT_ID FROM INSERTED) 
 END
GO

UPDATE CONFIG.SYSCONFIG_INFO SET INT_VALUE=7, CHAR_VALUE='4.0 RC2' WHERE INFO_ID=17
GO