SET CURRENT SCHEMA $CONFIG_SCHEMA;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=6);

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=7);

UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0' WHERE INFO_ID=7;

INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=8);
INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,6 AS INT_VALUE,'2.0.0.1 RC4' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=18);

DROP TRIGGER $NF_SCHEMA.TRG_REQREQUI;
CREATE TRIGGER $NF_SCHEMA.TRG_REQREQUI AFTER UPDATE OF REC_DATETIME ON $NF_SCHEMA.REQUEST
REFERENCING NEW AS NEWROW
OLD AS OLDROW
FOR EACH ROW MODE DB2SQL
DELETE FROM $NF_SCHEMA.REQUIREMENT_REQUEST_LOOKUP WHERE REQUEST_ID=NEWROW.REQUEST_ID AND NEWROW.REQUEST_CLASS_ID<>(SELECT REQUEST_CLASS_ID FROM $NF_SCHEMA.REQUEST_CLASSIFICATION WHERE NAME ='RTC WorkItem');



CREATE TRIGGER $NF_SCHEMA.TRG_REQREQUI2 AFTER UPDATE OF REC_DATETIME ON $NF_SCHEMA.REQUIREMENT
REFERENCING NEW AS NEWROW
OLD AS OLDROW
FOR EACH ROW MODE DB2SQL
DELETE FROM $NF_SCHEMA.REQUIREMENT_REQUEST_LOOKUP WHERE REQUIREMENT_ID=NEWROW.REQUIREMENT_ID AND NEWROW.REQUIREMENT_CLASS_ID=(SELECT REQUIREMENT_CLASS_ID FROM $NF_SCHEMA.REQUIREMENT_CLASSIFICATION WHERE NAME ='RRC Requirement');

UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0' WHERE INFO_ID=6;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET CHAR_VALUE='2.0.0.1 RC4',INT_VALUE=6 WHERE INFO_ID=18;