INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE WHERE NOT EXISTS(SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=6)
GO
INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE WHERE NOT EXISTS(SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=7)
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0' WHERE INFO_ID=7
GO

IF NOT EXISTS (SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=8) INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE ELSE UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET NAME='MIGRATION_STATUS',DISPLAY_NAME='Insight Warehouse Migration Status',INT_VALUE=0,CHAR_VALUE='' WHERE INFO_ID=8
GO
IF NOT EXISTS (SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=18) INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,6 AS INT_VALUE,'2.0.0.1 RC4' AS CHAR_VALUE ELSE UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET NAME='MINOR_VERSION',DISPLAY_NAME='Insight Warehouse Minor Version',INT_VALUE=4,CHAR_VALUE='2.0.0.1 RC4' WHERE INFO_ID=18
GO

DROP TRIGGER $(NF_SCHEMA).TRG_REQREQUI
GO

CREATE TRIGGER $(NF_SCHEMA).TRG_REQREQUI
    ON $(NF_SCHEMA).REQUEST

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN
DECLARE @cls int
  SELECT @cls=REQUEST_CLASS_ID FROM $(NF_SCHEMA).REQUEST_CLASSIFICATION WHERE NAME ='RTC WorkItem'
  BEGIN
  	DELETE FROM $(NF_SCHEMA).REQUIREMENT_REQUEST_LOOKUP  WHERE  REQUEST_ID IN (SELECT  REQUEST_ID FROM INSERTED )
  	AND @cls NOT IN (SELECT REQUEST_CLASS_ID FROM INSERTED)
 END
END
GO

CREATE TRIGGER $(NF_SCHEMA).TRG_REQREQUI2
    ON $(NF_SCHEMA).REQUIREMENT

    FOR UPDATE
AS
SET NOCOUNT ON
IF UPDATE(REC_DATETIME)
BEGIN
DECLARE @cls int
  SELECT @cls=REQUIREMENT_CLASS_ID FROM $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION WHERE NAME ='RRC Requirement'
  BEGIN
  	DELETE FROM $(NF_SCHEMA).REQUIREMENT_REQUEST_LOOKUP  WHERE  REQUIREMENT_ID IN (SELECT  REQUIREMENT_ID FROM INSERTED )
  	AND @cls IN (SELECT REQUIREMENT_CLASS_ID FROM INSERTED)
 END
END
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0' WHERE INFO_ID=6
GO
UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8
GO
UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET CHAR_VALUE='2.0.0.1 RC4',INT_VALUE=6 WHERE INFO_ID=18
GO