ALTER SESSION SET CURRENT_SCHEMA= &&CONFIG_SCHEMA;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM DUAL WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=6);

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE FROM DUAL WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=7);

UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0' WHERE INFO_ID=7;

MERGE INTO &&CONFIG_SCHEMA.SYSCONFIG_INFO M USING (SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE FROM DUAL) MM ON (M.INFO_ID=MM.INFO_ID) WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE,M.CHAR_VALUE=MM.CHAR_VALUE,M.REC_DATETIME=CURRENT_TIMESTAMP WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE) VALUES(8,'MIGRATION_STATUS','Insight Warehouse Migration Status',0);
MERGE INTO &&CONFIG_SCHEMA.SYSCONFIG_INFO M USING (SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,6 AS INT_VALUE,'2.0.0.1 RC4' AS CHAR_VALUE FROM DUAL) MM ON (M.INFO_ID=MM.INFO_ID) WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE,M.CHAR_VALUE=MM.CHAR_VALUE,M.REC_DATETIME=CURRENT_TIMESTAMP WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) VALUES (18,'MINOR_VERSION','Insight Warehouse Minor Version',6,'2.0.0.1 RC4');

DROP TRIGGER &&NF_SCHEMA.TRG_REQREQUI;

CREATE TRIGGER &&NF_SCHEMA.TRG_REQREQUI
	AFTER UPDATE OF REC_DATETIME ON &&NF_SCHEMA.REQUEST
	FOR EACH ROW
	DECLARE
  cls INTEGER;
BEGIN
SELECT REQUEST_CLASS_ID INTO cls FROM &&NF_SCHEMA.REQUEST_CLASSIFICATION WHERE NAME ='RTC WorkItem';
	IF (cls <> :NEW.REQUEST_CLASS_ID) THEN
    DELETE FROM &&NF_SCHEMA.REQUIREMENT_REQUEST_LOOKUP WHERE REQUEST_ID=:NEW.REQUEST_ID;
    END IF;
END;
/


CREATE TRIGGER &&NF_SCHEMA.TRG_REQREQUI2
	AFTER UPDATE OF REC_DATETIME ON &&NF_SCHEMA.REQUIREMENT
	FOR EACH ROW
	DECLARE
  cls INTEGER;
BEGIN
SELECT REQUIREMENT_CLASS_ID INTO cls FROM &&NF_SCHEMA.REQUIREMENT_CLASSIFICATION WHERE NAME ='RRC Requirement';
	IF (cls = :NEW.REQUIREMENT_CLASS_ID) THEN
    DELETE FROM &&NF_SCHEMA.REQUIREMENT_REQUEST_LOOKUP WHERE REQUIREMENT_ID=:NEW.REQUIREMENT_ID;
  END IF;
END;
/

UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0' WHERE INFO_ID=6;
UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8;
UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET CHAR_VALUE='2.0.0.1 RC4',INT_VALUE=6 WHERE INFO_ID=18;