ALTER SESSION SET CURRENT_SCHEMA= &&CONFIG_SCHEMA;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM DUAL WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=6);

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0.3' AS CHAR_VALUE FROM DUAL WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=7);

UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.3' WHERE INFO_ID=7;

MERGE INTO &&CONFIG_SCHEMA.SYSCONFIG_INFO M USING (SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE FROM DUAL) MM ON (M.INFO_ID=MM.INFO_ID) WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE,M.CHAR_VALUE=MM.CHAR_VALUE,M.REC_DATETIME=CURRENT_TIMESTAMP WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE) VALUES(8,'MIGRATION_STATUS','Insight Warehouse Migration Status',0);
MERGE INTO &&CONFIG_SCHEMA.SYSCONFIG_INFO M USING (SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,11 AS INT_VALUE,'2.0.3 RC1' AS CHAR_VALUE FROM DUAL) MM ON (M.INFO_ID=MM.INFO_ID) WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE,M.CHAR_VALUE=MM.CHAR_VALUE,M.REC_DATETIME=CURRENT_TIMESTAMP WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) VALUES (18,'MINOR_VERSION','Insight Warehouse Minor Version',11,'2.0.3 RC1');
MERGE INTO &&CONFIG_SCHEMA.SYSCONFIG_INFO M USING (SELECT  9 AS INFO_ID,'DATA_TRUNCATION' AS NAME,'Interpreted as do not compute or delete data with dates earlier or equal to the value set' AS DISPLAY_NAME,1 AS INT_VALUE,'1899-12-31' AS CHAR_VALUE FROM DUAL) MM ON (M.INFO_ID=MM.INFO_ID) WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) VALUES (9,'DATA_TRUNCATION','Interpreted as do not compute or delete data with dates earlier or equal to the value set',1,'1899-12-31');

CREATE INDEX &&NF_SCHEMA.TIMESHEET_IDX7 ON &&NF_SCHEMA.TIMESHEET (TIMESHEET_REPORTING_WEEK, ACTIVITY_ID, REFERENCE_ID) REVERSE TABLESPACE VNF_IDX;

DROP TRIGGER &&NF_SCHEMA.TRG_REQREQUI2;
CREATE TRIGGER &&NF_SCHEMA.TRG_REQREQUI2
	AFTER UPDATE OF REC_DATETIME ON &&NF_SCHEMA.REQUIREMENT
	FOR EACH ROW
BEGIN
    DELETE FROM &&NF_SCHEMA.REQUIREMENT_REQUEST_LOOKUP WHERE REQUIREMENT_ID=:NEW.REQUIREMENT_ID AND :NEW.REQUIREMENT_CLASS_ID IN
    (SELECT REQUIREMENT_CLASS_ID FROM &&NF_SCHEMA.REQUIREMENT_CLASSIFICATION WHERE NAME IN('RRC Requirement','Doors Requirement'));
END;
/

DROP TRIGGER &&NF_SCHEMA.TRG_TPTPHIER;
CREATE TRIGGER &&NF_SCHEMA.TRG_TPTPHIER
	AFTER UPDATE OF REC_DATETIME ON &&NF_SCHEMA.TESTPLAN
	FOR EACH ROW
	DECLARE
    cls INTEGER;
BEGIN
	SELECT TESTPLAN_CLASS_ID INTO cls FROM &&NF_SCHEMA.TESTPLAN_CLASSIFICATION WHERE NAME='RQM Test Plan';
	IF (cls<>:NEW.TESTPLAN_CLASS_ID) THEN
	DELETE FROM &&NF_SCHEMA.TESTPLAN_TESTPLAN_HIERARCHY
	WHERE PARENT_TESTPLAN_ID=:NEW.TESTPLAN_ID OR CHILD_TESTPLAN_ID=:NEW.TESTPLAN_ID;
	END IF;
END;
/

CREATE TRIGGER &&NF_SCHEMA.TRG_TPTPHIER2
	AFTER UPDATE OF REC_DATETIME ON &&NF_SCHEMA.TESTPLAN
	FOR EACH ROW
	DECLARE
    cls INTEGER;
BEGIN
	SELECT TESTPLAN_CLASS_ID INTO cls FROM &&NF_SCHEMA.TESTPLAN_CLASSIFICATION WHERE NAME='RQM Test Plan';
	IF (cls=:NEW.TESTPLAN_CLASS_ID) THEN
	DELETE FROM &&NF_SCHEMA.TESTPLAN_TESTPLAN_HIERARCHY
	WHERE PARENT_TESTPLAN_ID=:NEW.TESTPLAN_ID;
	END IF;
END;
/

UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.3' WHERE INFO_ID=6;
UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8;
UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET CHAR_VALUE='2.0.3 RC1',INT_VALUE=11 WHERE INFO_ID=18;