ALTER SESSION SET CURRENT_SCHEMA= &&CONFIG_SCHEMA;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM DUAL WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=6);

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0.5' AS CHAR_VALUE FROM DUAL WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=7);

UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.5' WHERE INFO_ID=7;

MERGE INTO &&CONFIG_SCHEMA.SYSCONFIG_INFO M USING (SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE FROM DUAL) MM ON (M.INFO_ID=MM.INFO_ID) WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE,M.CHAR_VALUE=MM.CHAR_VALUE,M.REC_DATETIME=CURRENT_TIMESTAMP WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE) VALUES(8,'MIGRATION_STATUS','Insight Warehouse Migration Status',0);
MERGE INTO &&CONFIG_SCHEMA.SYSCONFIG_INFO M USING (SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,15 AS INT_VALUE,'2.0.5 RC2' AS CHAR_VALUE FROM DUAL) MM ON (M.INFO_ID=MM.INFO_ID) WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE,M.CHAR_VALUE=MM.CHAR_VALUE,M.REC_DATETIME=CURRENT_TIMESTAMP WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) VALUES (18,'MINOR_VERSION','Insight Warehouse Minor Version',15,'2.0.5 RC2');
MERGE INTO &&CONFIG_SCHEMA.SYSCONFIG_INFO M USING (SELECT  9 AS INFO_ID,'DATA_TRUNCATION' AS NAME,'Interpreted as do not compute or delete data with dates earlier or equal to the value set' AS DISPLAY_NAME,1 AS INT_VALUE,'1899-12-31' AS CHAR_VALUE FROM DUAL) MM ON (M.INFO_ID=MM.INFO_ID) WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) VALUES (9,'DATA_TRUNCATION','Interpreted as do not compute or delete data with dates earlier or equal to the value set',1,'1899-12-31');

DROP VIEW &&STAR_SCHEMA..VW_RQRMNT_COVERAGE_LOOKUP;

CREATE VIEW &&STAR_SCHEMA..VW_RQRMNT_COVERAGE_LOOKUP (LOW_PROJECT_ID, LOW_ID, LOW_REF_ID, LOW_NAME, LOW_URL, LOW_TYPE, LOW_STATUS, LOW_PRIORITY, LOW_STABILITY, LOW_DIFFICULTY, LOW_STATE, UP_PROJECT_ID, UP_ID, UP_REF_ID, UP_NAME, UP_URL, UP_TYPE, UP_STATUS, UP_PRIORITY, UP_STABILITY, UP_DIFFICULTY, UP_STATE, LINK_TYPE_ID, LINK_TYPE) AS
(SELECT LR.PROJECT_ID AS LOW_PROJECT_ID, LR.REQUIREMENT_ID AS LOW_ID, LR.REFERENCE_ID AS LOW_REF_ID, LR.NAME AS LOW_NAME, LR.URL AS LOW_URL, LR.REQUIREMENT_TYPE AS LOW_TYPE, LR.STATUS AS LOW_STATUS, LR.PRIORITY AS LOW_PRIORITY, LR.STABILITY AS LOW_STABILITY, LR.DIFFICULTY AS LOW_DIFFICULTY, LR.REQUIREMENT_STATE AS LOW_STATE, 
		COALESCE(UR.PROJECT_ID, -1) AS UP_PROJECT_ID, COALESCE(UR.REQUIREMENT_ID,-1) AS UP_ID, UR.REFERENCE_ID AS UP_REF_ID, UR.NAME AS UP_NAME, UR.URL AS UP_URL, UR.REQUIREMENT_TYPE AS UP_TYPE, UR.STATUS AS UP_STATUS, UR.PRIORITY AS UP_PRIORITY, UR.STABILITY AS UP_STABILITY, UR.DIFFICULTY AS UP_DIFFICULTY, UR.REQUIREMENT_STATE AS UP_STATE, 
		COALESCE(LT.LINK_TYPE_ID,-1) AS LINK_TYPE_ID, LT.NAME AS LINK_TYPE
FROM &&NF_SCHEMA..REQUIREMENT LR 
LEFT JOIN &&NF_SCHEMA..REQUIREMENT_HIERARCHY H ON H.PRED_REQUIREMENT_ID = LR.REQUIREMENT_ID
LEFT JOIN &&NF_SCHEMA..REQUIREMENT_LINK_TYPE LT ON H.LINK_TYPE_ID = LT.LINK_TYPE_ID
LEFT JOIN &&NF_SCHEMA..REQUIREMENT UR ON H.SUCC_REQUIREMENT_ID = UR.REQUIREMENT_ID
WHERE LR.REQUIREMENT_ID > -1 AND LR.ISSOFTDELETED = 0
UNION
SELECT COALESCE(LR.PROJECT_ID, -1) AS LOW_PROJECT_ID, COALESCE(LR.REQUIREMENT_ID,-1) AS LOW_ID, LR.REFERENCE_ID AS LOW_REF_ID, LR.NAME AS LOW_NAME, LR.URL AS LOW_URL, LR.REQUIREMENT_TYPE AS LOW_TYPE, LR.STATUS AS LOW_STATUS, LR.PRIORITY AS LOW_PRIORITY, LR.STABILITY AS LOW_STABILITY, LR.DIFFICULTY AS LOW_DIFFICULTY, LR.REQUIREMENT_STATE AS LOW_STATE, 
		UR.PROJECT_ID AS UP_PROJECT_ID, UR.REQUIREMENT_ID AS UP_ID, UR.REFERENCE_ID AS UP_REF_ID, UR.NAME AS UP_NAME, UR.URL AS UP_URL, UR.REQUIREMENT_TYPE AS UP_TYPE, UR.STATUS AS UP_STATUS, UR.PRIORITY AS UP_PRIORITY, UR.STABILITY AS UP_STABILITY, UR.DIFFICULTY AS UP_DIFFICULTY, UR.REQUIREMENT_STATE AS UP_STATE, 
		COALESCE(LT.LINK_TYPE_ID,-1) AS LINK_TYPE_ID, LT.NAME AS LINK_TYPE
FROM &&NF_SCHEMA..REQUIREMENT UR 
LEFT JOIN &&NF_SCHEMA..REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UR.REQUIREMENT_ID
LEFT JOIN &&NF_SCHEMA..REQUIREMENT_LINK_TYPE LT ON H.LINK_TYPE_ID = LT.LINK_TYPE_ID
LEFT JOIN &&NF_SCHEMA..REQUIREMENT LR ON H.PRED_REQUIREMENT_ID = LR.REQUIREMENT_ID
WHERE UR.REQUIREMENT_ID > -1 AND UR.ISSOFTDELETED = 0);

GRANT SELECT ON &&STAR_SCHEMA..VW_RQRMNT_COVERAGE_LOOKUP TO &&REP_USER;

DROP VIEW &&STAR_SCHEMA..VW_TESTSCRIPT_STEP;
CREATE VIEW &&STAR_SCHEMA..VW_TESTSCRIPT_STEP (TESTSCRIPT_STEP_ID,NAME,REFERENCE_ID,EXTERNAL_ID,TESTSCRIPT_ID,TESTSCRIPT_NAME,PROJECT_ID,PROJECT_NAME,DESCRIPTION,EXPECTED_RESULT,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT S.TESTSCRIPT_STEP_ID,S.NAME,S.REFERENCE_ID,S.EXTERNAL_ID,S.TESTSCRIPT_ID,T.NAME AS TESTSCRIPT_NAME,P.PROJECT_ID,P.NAME AS PROJECT_NAME,S.DESCRIPTION,S.EXPECTED_RESULT,S.URL,S.EXTERNAL_KEY1,S.EXTERNAL_KEY2,S.SOURCE_ID,S.REC_DATETIME,S.ISSOFTDELETED
FROM  &&NF_SCHEMA..TESTSCRIPT_STEP S
JOIN  &&NF_SCHEMA..TESTSCRIPT T ON T.TESTSCRIPT_ID =S.TESTSCRIPT_ID
JOIN  &&NF_SCHEMA..PROJECT P ON P.PROJECT_ID =T.PROJECT_ID);
GRANT SELECT ON &&STAR_SCHEMA..VW_TESTSCRIPT_STEP TO &&REP_USER;

UPDATE &&NF_SCHEMA..REQUIREMENT_SCRIPTSTEP_LOOKUP SET LINK_TYPE = 'Unassigned' WHERE LINK_TYPE IS NULL;
ALTER TABLE &&NF_SCHEMA..REQUIREMENT_SCRIPTSTEP_LOOKUP MODIFY LINK_TYPE VARCHAR(255) NOT NULL;
ALTER TABLE &&NF_SCHEMA..REQUIREMENT_SCRIPTSTEP_LOOKUP DROP CONSTRAINT REQSCRSTEP_PK;
ALTER TABLE &&NF_SCHEMA..REQUIREMENT_SCRIPTSTEP_LOOKUP ADD CONSTRAINT REQSCRSTEP_PK PRIMARY KEY (REQUIREMENT_ID,TESTSCRIPT_STEP_ID,LINK_TYPE) USING INDEX TABLESPACE  VNF_IDX;

UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.5' WHERE INFO_ID=6;
UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8;
UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET CHAR_VALUE='2.0.5 RC2',INT_VALUE=15 WHERE INFO_ID=18;
