SET CURRENT SCHEMA $CONFIG_SCHEMA;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=6);

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=7);

UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.5' WHERE INFO_ID=7;

INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=8);
INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,13 AS INT_VALUE,'2.0.5 S2' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=18);
INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT 9 AS INFO_ID,'DATA_TRUNCATION' AS NAME,'Interpreted as do not compute or delete data with dates earlier or equal to the value set' AS DISPLAY_NAME,1 AS INT_VALUE,'1899-12-31' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME  from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=9);

SET CURRENT SCHEMA $STAR_SCHEMA;

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_REF_METRICS_BYCOLL DROP CONSTRAINT HRQRFMET_FK1;

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT HRQRFMET_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL (REQ_METRIC_ID) ON DELETE CASCADE;

SET CURRENT SCHEMA $NF_SCHEMA;

CREATE TABLE $NF_SCHEMA.TESTSCRIPT_STEP (		TESTSCRIPT_STEP_ID INTEGER NOT NULL,		NAME VARCHAR(255) DEFAULT 'Test Script Step Name Missing' NOT NULL,		REFERENCE_ID VARCHAR(50),		EXTERNAL_ID VARCHAR(100),		TESTSCRIPT_ID INTEGER DEFAULT -1 NOT NULL,		DESCRIPTION VARCHAR (255),		EXPECTED_RESULT VARCHAR (255),		URL VARCHAR(2048),		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,		EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,		SOURCE_ID VARCHAR (36) DEFAULT '-1' NOT NULL,		REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL,		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL);
CREATE TABLE $NF_SCHEMA.REQUIREMENT_SCRIPTSTEP_LOOKUP (	REQUIREMENT_ID INTEGER NOT NULL,	TESTSCRIPT_STEP_ID INTEGER NOT NULL,	LINK_TYPE VARCHAR(255) DEFAULT 'Unassigned' NOT NULL);

CREATE INDEX $NF_SCHEMA.TSTSCRSTEP_IDX1 ON $NF_SCHEMA.TESTSCRIPT_STEP (EXTERNAL_KEY2);
CREATE INDEX $NF_SCHEMA.TSTSCRSTEP_IDX2 ON $NF_SCHEMA.TESTSCRIPT_STEP (EXTERNAL_KEY1);
CREATE INDEX $NF_SCHEMA.TSTSCRSTEP_IDX3 ON $NF_SCHEMA.TESTSCRIPT_STEP (EXTERNAL_KEY2,SOURCE_ID);
CREATE INDEX $NF_SCHEMA.TSTSCRSTEP_IDX4 ON $NF_SCHEMA.TESTSCRIPT_STEP (EXTERNAL_KEY1,SOURCE_ID);
CREATE INDEX $NF_SCHEMA.TSTSCRSTEP_IDX5 ON $NF_SCHEMA.TESTSCRIPT_STEP (EXTERNAL_ID);
CREATE INDEX $NF_SCHEMA.TSTSCRSTEP_IDX6 ON $NF_SCHEMA.TESTSCRIPT_STEP (ISSOFTDELETED);

ALTER TABLE $NF_SCHEMA.TESTSCRIPT_STEP ADD CONSTRAINT $NF_SCHEMA.TSTSCRSTEP_PK PRIMARY KEY (TESTSCRIPT_STEP_ID);

ALTER TABLE $NF_SCHEMA.REQUIREMENT_SCRIPTSTEP_LOOKUP ADD CONSTRAINT $NF_SCHEMA.REQSCRSTEP_PK PRIMARY KEY (REQUIREMENT_ID,TESTSCRIPT_STEP_ID,LINK_TYPE);

ALTER TABLE $NF_SCHEMA.TESTSCRIPT_STEP ADD CONSTRAINT $NF_SCHEMA.TSTSCRSTEP_FK1 FOREIGN KEY (TESTSCRIPT_ID)	REFERENCES $NF_SCHEMA.TESTSCRIPT (TESTSCRIPT_ID);

ALTER TABLE $NF_SCHEMA.REQUIREMENT_SCRIPTSTEP_LOOKUP ADD CONSTRAINT $NF_SCHEMA.REQSCRSTEP_FK1 FOREIGN KEY (REQUIREMENT_ID) REFERENCES $NF_SCHEMA.REQUIREMENT (REQUIREMENT_ID);

ALTER TABLE $NF_SCHEMA.REQUIREMENT_SCRIPTSTEP_LOOKUP ADD CONSTRAINT $NF_SCHEMA.REQSCRSTEP_FK2 FOREIGN KEY (TESTSCRIPT_STEP_ID) REFERENCES $NF_SCHEMA.TESTSCRIPT_STEP (TESTSCRIPT_STEP_ID);

CREATE TRIGGER $NF_SCHEMA.TRG_REQUISCRSTEP
	AFTER UPDATE OF REC_DATETIME ON $NF_SCHEMA.TESTSCRIPT_STEP
	REFERENCING NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
BEGIN ATOMIC
	DELETE FROM $NF_SCHEMA.REQUIREMENT_SCRIPTSTEP_LOOKUP WHERE TESTSCRIPT_STEP_ID=NEWROW.TESTSCRIPT_STEP_ID; END;


INSERT INTO $NF_SCHEMA.TESTSCRIPT_STEP (TESTSCRIPT_STEP_ID, NAME) VALUES (-1, 'Info Not Available');

SET CURRENT SCHEMA $STAR_SCHEMA;

CREATE VIEW $STAR_SCHEMA.VW_TESTSCRIPT_STEP (TESTSCRIPT_STEP_ID,NAME,REFERENCE_ID,EXTERNAL_ID,TESTSCRIPT_ID,TESTSCRIPT_NAME,DESCRIPTION,EXPECTED_RESULT,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT S.TESTSCRIPT_STEP_ID,S.NAME,S.REFERENCE_ID,S.EXTERNAL_ID,S.TESTSCRIPT_ID,T.NAME AS TESTSCRIPT_NAME,S.DESCRIPTION,S.EXPECTED_RESULT,S.URL,S.EXTERNAL_KEY1,S.EXTERNAL_KEY2,S.SOURCE_ID,S.REC_DATETIME,S.ISSOFTDELETED
FROM $NF_SCHEMA.TESTSCRIPT_STEP S
JOIN $NF_SCHEMA.TESTSCRIPT T ON T.TESTSCRIPT_ID =S.TESTSCRIPT_ID);

CREATE VIEW $STAR_SCHEMA.VW_REQUIREME_SCRIPTSTEP_LOOKUP(REQUIREMENT_ID,REQUIREMENT_NAME,TESTSCRIPT_STEP_ID,TESTSCRIPT_STEP_NAME,LINK_TYPE) AS
(SELECT RS.REQUIREMENT_ID,R.NAME AS REQUIREMENT_NAME,RS.TESTSCRIPT_STEP_ID,S.NAME AS TESTSCRIPT_STEP_NAME,RS.LINK_TYPE
FROM $NF_SCHEMA.REQUIREMENT_SCRIPTSTEP_LOOKUP RS
JOIN $NF_SCHEMA.REQUIREMENT R ON R.REQUIREMENT_ID =RS.REQUIREMENT_ID
JOIN $NF_SCHEMA.TESTSCRIPT_STEP S ON S.TESTSCRIPT_STEP_ID=RS.TESTSCRIPT_STEP_ID);

GRANT SELECT ON $STAR_SCHEMA.VW_TESTSCRIPT_STEP TO REPUSER;
GRANT SELECT ON $STAR_SCHEMA.VW_REQUIREME_SCRIPTSTEP_LOOKUP TO REPUSER;

CREATE TABLE $STAR_SCHEMA.D_COVERAGE (
	COVERAGE_ID INT NOT NULL,
	NAME VARCHAR(255) NOT NULL
	) 
	;

CREATE TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_WI_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		COLLECTION_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		COVERAGE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_STATUS_ID INTEGER NOT NULL,
		TOTAL_MBR_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	)
	;

CREATE TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		COLLECTION_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		COVERAGE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_STATUS_ID INTEGER NOT NULL,
		TOTAL_MBR_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	)
	;

CREATE TABLE $STAR_SCHEMA.H_MEMBER_RQRMNT_WI_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL
	)
	;

CREATE TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_TC_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		COLLECTION_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		COVERAGE_ID INTEGER NOT NULL,
		TESTCASE_STATE_ID INTEGER NOT NULL,
		TOTAL_MBR_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	)
	;

CREATE TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_TC_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		COLLECTION_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		COVERAGE_ID INTEGER NOT NULL,
		TESTCASE_STATE_ID INTEGER NOT NULL,
		TOTAL_MBR_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	)
	;

CREATE TABLE $STAR_SCHEMA.H_MEMBER_RQRMNT_TC_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL
	)
	;

CREATE TABLE $STAR_SCHEMA.F_C_MBR_RQRMNT_TC_ER_WI_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		COLLECTION_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TESTCASE_STATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_STATUS_ID INTEGER NOT NULL,
		TOTAL_MBR_RQRMNTS_W_TC_ER_WI INTEGER DEFAULT 0 NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	)
	;

CREATE TABLE $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		COLLECTION_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TESTCASE_STATE_ID INTEGER NOT NULL,
		REQUEST_TYPE_ID INTEGER NOT NULL,
		REQUEST_STATUS_ID INTEGER NOT NULL,
		TOTAL_MBR_RQRMNTS_W_TC_ER_WI INTEGER DEFAULT 0 NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	)
	;

CREATE TABLE $STAR_SCHEMA.H_MBR_RQRMNT_TC_ER_WI_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL
	)
	;

CREATE INDEX $STAR_SCHEMA.F_RQWIMT_IDX1 ON $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL (DATE_ID);
CREATE INDEX $STAR_SCHEMA.F_RQTCMT_IDX1 ON $STAR_SCHEMA.F_MEMBER_RQRMNT_TC_BYCOLL (DATE_ID);
CREATE INDEX $STAR_SCHEMA.F_RQTCERWIMT_IDX1 ON $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL (DATE_ID);

ALTER TABLE $STAR_SCHEMA.D_COVERAGE ADD CONSTRAINT D_COV_PK PRIMARY KEY	(COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_C_RQWIMT_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_RQWIMT_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.H_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT H_RQWIMT_PK PRIMARY KEY (REQ_METRIC_ID, REQUIREMENT_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_C_RQTCMT_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_RQTCMT_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.H_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT H_RQTCMT_PK PRIMARY KEY (REQ_METRIC_ID, REQUIREMENT_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_C_RQTCERWIMT_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_RQTCERWIMT_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.H_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT H_RQTCERWIMT_PK PRIMARY KEY (REQ_METRIC_ID, REQUIREMENT_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_C_RQWIMT_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_C_RQWIMT_FK2 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_C_RQWIMT_FK3 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUEST_TYPE (REQUEST_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_C_RQWIMT_FK4 FOREIGN KEY (REQUEST_STATUS_ID)
	REFERENCES $STAR_SCHEMA.D_REQUEST_STATUS (STATUS_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_C_RQWIMT_FK5 FOREIGN KEY (OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_C_RQWIMT_FK6 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_C_RQWIMT_FK7 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_RQWIMT_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_RQWIMT_FK2 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_RQWIMT_FK3 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUEST_TYPE (REQUEST_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_RQWIMT_FK4 FOREIGN KEY (REQUEST_STATUS_ID)
	REFERENCES $STAR_SCHEMA.D_REQUEST_STATUS (STATUS_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_RQWIMT_FK5 FOREIGN KEY (OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_RQWIMT_FK6 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT F_RQWIMT_FK7 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.H_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT H_RQWIMT_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL (REQ_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.H_MEMBER_RQRMNT_WI_BYCOLL ADD CONSTRAINT H_RQWIMT_FK2 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_C_RQTCMT_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_C_RQTCMT_FK2 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_C_RQTCMT_FK3 FOREIGN KEY (TESTCASE_STATE_ID)
	REFERENCES $STAR_SCHEMA.D_TESTCASE_STATE (STATE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_C_RQTCMT_FK4 FOREIGN KEY (OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_C_RQTCMT_FK5 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_C_RQTCMT_FK6 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_RQTCMT_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_RQTCMT_FK2 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_RQTCMT_FK3 FOREIGN KEY (TESTCASE_STATE_ID)
	REFERENCES $STAR_SCHEMA.D_TESTCASE_STATE (STATE_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_RQTCMT_FK4 FOREIGN KEY (OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_RQTCMT_FK5 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT F_RQTCMT_FK6 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.H_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT H_RQTCMT_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $STAR_SCHEMA.F_MEMBER_RQRMNT_TC_BYCOLL (REQ_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.H_MEMBER_RQRMNT_TC_BYCOLL ADD CONSTRAINT H_RQTCMT_FK2 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.F_C_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_C_RQTCERWIMT_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_C_RQTCERWIMT_FK2 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_C_RQTCERWIMT_FK3 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUEST_TYPE (REQUEST_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_C_RQTCERWIMT_FK4 FOREIGN KEY (REQUEST_STATUS_ID)
	REFERENCES $STAR_SCHEMA.D_REQUEST_STATUS (STATUS_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_C_RQTCERWIMT_FK5 FOREIGN KEY (OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_C_RQTCERWIMT_FK6 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_C_RQTCERWIMT_FK7 FOREIGN KEY (TESTCASE_STATE_ID)
	REFERENCES $STAR_SCHEMA.D_TESTCASE_STATE (STATE_ID);

ALTER TABLE $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_RQTCERWIMT_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);

ALTER TABLE $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_RQTCERWIMT_FK2 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_RQTCERWIMT_FK3 FOREIGN KEY (REQUEST_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUEST_TYPE (REQUEST_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_RQTCERWIMT_FK4 FOREIGN KEY (REQUEST_STATUS_ID)
	REFERENCES $STAR_SCHEMA.D_REQUEST_STATUS (STATUS_ID);

ALTER TABLE $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_RQTCERWIMT_FK5 FOREIGN KEY (OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_RQTCERWIMT_FK6 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT F_RQTCERWIMT_FK7 FOREIGN KEY (TESTCASE_STATE_ID)
	REFERENCES $STAR_SCHEMA.D_TESTCASE_STATE (STATE_ID);

ALTER TABLE $STAR_SCHEMA.H_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT H_RQTCERWIMT_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL (REQ_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.H_MBR_RQRMNT_TC_ER_WI_BYCOLL ADD CONSTRAINT H_RQTCERWIMT_FK2 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE;

CREATE VIEW $STAR_SCHEMA.VW_RQRMNT_WI_LOOKUP (REQUIREMENT_COLLECTION_ID, REQUIREMENT_ID, REFERENCE_ID, NAME, URL, REQUIREMENT_TYPE, STATUS, PRIORITY, STABILITY, DIFFICULTY, STATE, REQUEST_ID, WI_REFERENCE_ID, REQUEST_NAME, REQUEST_URL, REQUEST_TYPE_ID, REQUEST_TYPE_NAME, REQUEST_STATUS_ID, REQUEST_STATUS) AS 
(SELECT RC.REQUIREMENT_COLLECTION_ID, R.REQUIREMENT_ID, R.REFERENCE_ID, R.NAME, R.URL, R.REQUIREMENT_TYPE, R.STATUS, R.PRIORITY, R.STABILITY, R.DIFFICULTY, R.REQUIREMENT_STATE AS STATE, 
		COALESCE(WI.REQUEST_ID,-1) AS REQUEST_ID, WI.REFERENCE_ID AS WI_REFERENCE_ID, WI.NAME AS REQUEST_NAME, WI.URL AS REQUEST_URL, 
		COALESCE(T.REQUEST_TYPE_ID,-1) AS REQUEST_TYPE_ID, T.NAME AS REQUEST_TYPE_NAME, 
		COALESCE(S.REQUEST_STATUS_ID,-1) AS REQUEST_STATUS_ID, S.NAME AS REQUEST_STATUS
FROM $NF_SCHEMA.REQUIREMENT R 
JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP RC ON RC.REQUIREMENT_ID = R.REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.REQUIREMENT_REQUEST_LOOKUP RR ON RR.REQUIREMENT_ID = R.REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.REQUEST WI ON RR.REQUEST_ID = WI.REQUEST_ID
LEFT JOIN $NF_SCHEMA.REQUEST_TYPE T ON T.REQUEST_TYPE_ID = WI.REQUEST_TYPE_ID
LEFT JOIN $NF_SCHEMA.REQUEST_STATUS S ON WI.REQUEST_STATUS_ID = S.REQUEST_STATUS_ID);

CREATE VIEW $STAR_SCHEMA.VW_RQRMNT_TC_LOOKUP (REQUIREMENT_COLLECTION_ID, REQUIREMENT_ID, REFERENCE_ID, NAME, URL, REQUIREMENT_TYPE, STATUS, PRIORITY, STABILITY, DIFFICULTY, STATE, TESTCASE_ID, TC_REFERENCE_ID, TESTCASE_NAME, TESTCASE_URL, TESTCASE_STATE_ID, TESTCASE_STATE) AS 
(SELECT RC.REQUIREMENT_COLLECTION_ID, R.REQUIREMENT_ID, R.REFERENCE_ID ,R.NAME, R.URL, R.REQUIREMENT_TYPE, R.STATUS, R.PRIORITY, R.STABILITY, R.DIFFICULTY, R.REQUIREMENT_STATE AS STATE, 
		COALESCE(TC.TESTCASE_ID, -1) AS TESTCASE_ID, TC.REFERENCE_ID AS TC_REFERENCE_ID, TC.NAME AS TESTCASE_NAME, TC.URL AS TESTCASE_URL, 
		COALESCE(S.TESTCASE_STATE_ID,-1) AS TESTCASE_STATE_ID, S.NAME AS TESTCASE_STATE
FROM $NF_SCHEMA.REQUIREMENT R 
JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP RC ON RC.REQUIREMENT_ID = R.REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.REQUIREMENT_TESTCASE_LOOKUP RT ON RT.REQUIREMENT_ID = R.REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.TESTCASE TC ON RT.TESTCASE_ID = TC.TESTCASE_ID
LEFT JOIN $NF_SCHEMA.TESTCASE_STATE S ON TC.TESTCASE_STATE_ID = S.TESTCASE_STATE_ID);

CREATE VIEW $STAR_SCHEMA.VW_RQRMNT_TC_ER_WI_LOOKUP (REQUIREMENT_ID, REFERENCE_ID, NAME, URL, STATUS, PRIORITY, REQUIREMENT_TYPE, TESTCASE_ID, TESTCASE_NAME, TESTCASE_URL, TESTCASE_STATE_ID, TESTCASE_STATE, TESTPLAN_NAME, TESTPLAN_URL, EXECWORKITEM_ID, EXECWORKITEM_NAME, EXECWORKITEM_URL, RESULT_ID, RESULT_NAME, RESULT_VERDICT, REQUEST_ID, REQUEST_NAME, REQUEST_URL, REQUEST_TYPE_ID, REQUEST_TYPE_NAME, REQUEST_STATUS_ID, REQUEST_STATUS) AS
(SELECT R.REQUIREMENT_ID, R.REFERENCE_ID, R.NAME, R.URL, R.STATUS, R.PRIORITY, R.REQUIREMENT_TYPE, 
		TC.TESTCASE_ID, TC.NAME AS TESTCASE_NAME, TC.URL AS TESTCASE_URL, 
		TS.TESTCASE_STATE_ID, TS.NAME AS TESTCASE_STATE,
		TP.NAME AS TESTPLAN_NAME, TP.URL AS TESTPLAN_URL,
		ERWI.EXECWORKITEM_ID, ERWI.NAME AS EXECWORKITEM_NAME, ERWI.URL AS EXECWORKITEM_URL,
		ER.EXECUTION_RESULT_ID AS RESULT_ID, ER.NAME AS RESULT_NAME, ER.VERDICT AS RESULT_VERDICT,  
		WI.REQUEST_ID, WI.NAME AS REQUEST_NAME, WI.URL AS REQUEST_URL, 
		T.REQUEST_TYPE_ID, T.NAME AS REQUEST_TYPE_NAME, S.REQUEST_STATUS_ID, S.NAME AS REQUEST_STATUS
FROM $NF_SCHEMA.REQUIREMENT R 
JOIN $NF_SCHEMA.REQUIREMENT_TESTCASE_LOOKUP RT ON RT.REQUIREMENT_ID = R.REQUIREMENT_ID
JOIN $NF_SCHEMA.TESTCASE TC ON RT.TESTCASE_ID = TC.TESTCASE_ID
JOIN $NF_SCHEMA.TESTCASE_STATE TS ON TC.TESTCASE_STATE_ID = TS.TESTCASE_STATE_ID
JOIN $NF_SCHEMA.EXECUTION_WORKITEM ERWI ON ERWI.TESTCASE_ID = TC.TESTCASE_ID
JOIN $NF_SCHEMA.EXECUTION_RESULT ER ON ERWI.CURRENT_RESULT_ID = ER.EXECUTION_RESULT_ID
LEFT JOIN $NF_SCHEMA.TESTPLAN_TESTCASE_LOOKUP TPTC ON TPTC.TESTCASE_ID = TC.TESTCASE_ID
LEFT JOIN $NF_SCHEMA.TESTPLAN TP ON TPTC.TESTPLAN_ID = TP.TESTPLAN_ID
LEFT JOIN $NF_SCHEMA.EXECRES_REQUEST_LOOKUP EQ ON EQ.EXECUTION_RESULT_ID = ER.EXECUTION_RESULT_ID
LEFT JOIN $NF_SCHEMA.REQUEST WI ON EQ.REQUEST_ID = WI.REQUEST_ID
LEFT JOIN $NF_SCHEMA.REQUEST_TYPE T ON T.REQUEST_TYPE_ID = WI.REQUEST_TYPE_ID
LEFT JOIN $NF_SCHEMA.REQUEST_STATUS S ON WI.REQUEST_STATUS_ID = S.REQUEST_STATUS_ID);

INSERT INTO $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID, NAME) VALUES (-1,'Info not available');
INSERT INTO $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID, NAME) VALUES (0,'Not Covered');
INSERT INTO $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID, NAME) VALUES (1,'Covered');

GRANT SELECT ON TABLE $STAR_SCHEMA.D_COVERAGE TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_C_MBR_RQRMNT_TC_ER_WI_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_TC_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_C_MEMBER_RQRMNT_WI_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_MBR_RQRMNT_TC_ER_WI_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_TC_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_MEMBER_RQRMNT_WI_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.H_MBR_RQRMNT_TC_ER_WI_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.H_MEMBER_RQRMNT_TC_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.H_MEMBER_RQRMNT_WI_BYCOLL TO REPUSER;

GRANT SELECT ON $STAR_SCHEMA.VW_RQRMNT_TC_ER_WI_LOOKUP TO REPUSER;
GRANT SELECT ON $STAR_SCHEMA.VW_RQRMNT_TC_LOOKUP TO REPUSER;
GRANT SELECT ON $STAR_SCHEMA.VW_RQRMNT_WI_LOOKUP TO REPUSER;

CREATE TABLE $STAR_SCHEMA.D_LINK_TYPE (
	LINK_TYPE_ID INTEGER NOT NULL,
	NAME VARCHAR(255) NOT NULL,
	ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
	);

CREATE TABLE $STAR_SCHEMA.F_C_RQRMNT_UPCOVER_BYCOLL (
	REQ_METRIC_ID INTEGER NOT NULL,
	DATE_ID INTEGER NOT NULL,
	LOWER_OWNER_ID INTEGER NOT NULL,
	REQUIREMENT_TYPE_ID INTEGER NOT NULL,
	COVERAGE_ID INTEGER NOT NULL,
	LOWER_COLLECTION_ID INTEGER NOT NULL,
	UPPER_COLL_ID INTEGER NOT NULL,
	LINK_TYPE_ID INTEGER NOT NULL,
	TOTAL_COVERED_LOW_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	);

CREATE TABLE $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL (
	REQ_METRIC_ID INTEGER NOT NULL,
	DATE_ID INTEGER NOT NULL,
	LOWER_OWNER_ID INTEGER NOT NULL,
	REQUIREMENT_TYPE_ID INTEGER NOT NULL,
	COVERAGE_ID INTEGER NOT NULL,
	LOWER_COLLECTION_ID INTEGER NOT NULL,
	UPPER_COLL_ID INTEGER NOT NULL,
	LINK_TYPE_ID INTEGER NOT NULL,
	TOTAL_COVERED_LOW_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	);

CREATE TABLE $STAR_SCHEMA.H_RQRMNT_UPCOVER_BYCOLL (
	REQ_METRIC_ID INTEGER NOT NULL,
	LOWER_REQUIREMENT_ID INTEGER NOT NULL,
	UPPER_REQUIREMENT_ID INTEGER NOT NULL
	);

CREATE TABLE $STAR_SCHEMA.F_C_RQRMNT_DOWNGAP_BYCOLL (
	REQ_METRIC_ID INTEGER NOT NULL,
	DATE_ID INTEGER NOT NULL,
	UPPER_OWNER_ID INTEGER NOT NULL,
	REQUIREMENT_TYPE_ID INTEGER NOT NULL,
	COVERAGE_ID INTEGER NOT NULL,
	UPPER_COLLECTION_ID INTEGER NOT NULL,
	LOWER_COLL_ID INTEGER NOT NULL,
	LINK_TYPE_ID INTEGER NOT NULL,
	TOTAL_UPPER_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	);

CREATE TABLE $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL (
	REQ_METRIC_ID INTEGER NOT NULL,
	DATE_ID INTEGER NOT NULL,
	UPPER_OWNER_ID INTEGER NOT NULL,
	REQUIREMENT_TYPE_ID INTEGER NOT NULL,
	COVERAGE_ID INTEGER NOT NULL,
	UPPER_COLLECTION_ID INTEGER NOT NULL,
	LOWER_COLL_ID INTEGER NOT NULL,
	LINK_TYPE_ID INTEGER NOT NULL,
	TOTAL_UPPER_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	);

CREATE TABLE $STAR_SCHEMA.H_RQRMNT_DOWNGAP_BYCOLL (
	REQ_METRIC_ID INTEGER NOT NULL,
	UPPER_REQUIREMENT_ID INTEGER NOT NULL,
	LOWER_REQUIREMENT_ID INTEGER NOT NULL
	);

CREATE TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL (
	REQ_METRIC_ID INTEGER NOT NULL,
	DATE_ID INTEGER NOT NULL,
	REQUIREMENT_TYPE_ID INTEGER NOT NULL,
	LINK_TYPE_ID INTEGER NOT NULL,
	COVERAGE_ID INTEGER NOT NULL,
	TOTAL_LOWER_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
	TOTAL_UPPER_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	);

CREATE TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL (
	REQ_METRIC_ID INTEGER NOT NULL,
	DATE_ID INTEGER NOT NULL,
	REQUIREMENT_TYPE_ID INTEGER NOT NULL,
	LINK_TYPE_ID INTEGER NOT NULL,
	COVERAGE_ID INTEGER NOT NULL,
	TOTAL_LOWER_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
	TOTAL_UPPER_RQRMNTS INTEGER DEFAULT 0 NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	);

CREATE INDEX $STAR_SCHEMA.F_RQRUPCOV_IDX1 ON $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL (DATE_ID);
CREATE INDEX $STAR_SCHEMA.F_RQDOWNGP_IDX1 ON $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL (DATE_ID);
CREATE INDEX $STAR_SCHEMA.F_RQRCOV_IDX1 ON $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL (DATE_ID);

ALTER TABLE $STAR_SCHEMA.D_LINK_TYPE ADD CONSTRAINT D_LNKTYPE_PK PRIMARY KEY (LINK_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_C_RQUPCOV_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_RQUPCOV_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT H_RQUPCOV_PK PRIMARY KEY (REQ_METRIC_ID, LOWER_REQUIREMENT_ID, UPPER_REQUIREMENT_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_C_RQGAPCOV_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_RQGAPCOV_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT H_RQGAPCOV_PK PRIMARY KEY (REQ_METRIC_ID, UPPER_REQUIREMENT_ID, LOWER_REQUIREMENT_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_C_RQRCOV_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_RQRCOV_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_C_RQUPCOV_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_C_RQUPCOV_FK2 FOREIGN KEY (LOWER_OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_C_RQUPCOV_FK3 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_C_RQUPCOV_FK4 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_C_RQUPCOV_FK5 FOREIGN KEY (LOWER_COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_C_RQUPCOV_FK6 FOREIGN KEY (UPPER_COLL_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_C_RQUPCOV_FK7 FOREIGN KEY (LINK_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_LINK_TYPE (LINK_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_RQUPCOV_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_RQUPCOV_FK2 FOREIGN KEY (LOWER_OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_RQUPCOV_FK3 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_RQUPCOV_FK4 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_RQUPCOV_FK5 FOREIGN KEY (LOWER_COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_RQUPCOV_FK6 FOREIGN KEY (UPPER_COLL_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT F_RQUPCOV_FK7 FOREIGN KEY (LINK_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_LINK_TYPE (LINK_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT H_RQUPCOV_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL (REQ_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT H_RQUPCOV_FK2 FOREIGN KEY (LOWER_REQUIREMENT_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_UPCOVER_BYCOLL ADD CONSTRAINT H_RQUPCOV_FK3 FOREIGN KEY (UPPER_REQUIREMENT_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT (REQUIREMENT_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_C_RQGAPCOV_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_C_RQGAPCOV_FK2 FOREIGN KEY (UPPER_OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_C_RQGAPCOV_FK3 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_C_RQGAPCOV_FK4 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_C_RQGAPCOV_FK5 FOREIGN KEY (LOWER_COLL_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_C_RQGAPCOV_FK6 FOREIGN KEY (UPPER_COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_C_RQGAPCOV_FK7 FOREIGN KEY (LINK_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_LINK_TYPE (LINK_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_RQGAPCOV_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_RQGAPCOV_FK2 FOREIGN KEY (UPPER_OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_RQGAPCOV_FK3 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_RQGAPCOV_FK4 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_RQGAPCOV_FK5 FOREIGN KEY (LOWER_COLL_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_RQGAPCOV_FK6 FOREIGN KEY (UPPER_COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT F_RQGAPCOV_FK7 FOREIGN KEY (LINK_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_LINK_TYPE (LINK_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT H_RQGAPCOV_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL (REQ_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT H_RQGAPCOV_FK2 FOREIGN KEY (LOWER_REQUIREMENT_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT (REQUIREMENT_ID);

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_DOWNGAP_BYCOLL ADD CONSTRAINT H_RQGAPCOV_FK3 FOREIGN KEY (UPPER_REQUIREMENT_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_C_RQRCOV_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_C_RQRCOV_FK2 FOREIGN KEY (LINK_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_LINK_TYPE (LINK_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_C_RQRCOV_FK3 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_C_RQRCOV_FK4 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_RQRCOV_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_RQRCOV_FK2 FOREIGN KEY (LINK_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_LINK_TYPE (LINK_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_RQRCOV_FK3 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_RQRCOV_FK4 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

CREATE VIEW $STAR_SCHEMA.VW_RQRMNT_COVERAGE_LOOKUP (LOW_ID, LOW_NAME, LOW_URL, LOW_STATUS, LOW_PRIORITY, LOW_STABILITY, LOW_DIFFICULTY, LOW_STATE, UP_ID, UP_NAME, UP_URL, UP_STATUS, UP_PRIORITY, UP_STABILITY, UP_DIFFICULTY, UP_STATE, LINK_TYPE_ID, LINK_TYPE) AS
(SELECT LR.REQUIREMENT_ID AS LOW_ID, LR.NAME AS LOW_NAME, LR.URL AS LOW_URL, LR.STATUS AS LOW_STATUS, LR.PRIORITY AS LOW_PRIORITY, LR.STABILITY AS LOW_STABILITY, LR.DIFFICULTY AS LOW_DIFFICULTY, LR.REQUIREMENT_STATE AS LOW_STATE, 
		UR.REQUIREMENT_ID AS UP_ID, UR.NAME AS UP_NAME, UR.URL AS UP_URL, UR.STATUS AS UP_STATUS, UR.PRIORITY AS UP_PRIORITY, UR.STABILITY AS UP_STABILITY, UR.DIFFICULTY AS UP_DIFFICULTY, UR.REQUIREMENT_STATE AS UP_STATE, 
		LT.LINK_TYPE_ID, LT.NAME AS LINK_TYPE
FROM $NF_SCHEMA.REQUIREMENT_HIERARCHY H
JOIN $NF_SCHEMA.REQUIREMENT LR ON H.PRED_REQUIREMENT_ID = LR.REQUIREMENT_ID
JOIN $NF_SCHEMA.REQUIREMENT UR ON H.SUCC_REQUIREMENT_ID = UR.REQUIREMENT_ID
JOIN $NF_SCHEMA.REQUIREMENT_LINK_TYPE LT ON H.LINK_TYPE_ID = LT.LINK_TYPE_ID);

GRANT SELECT ON TABLE $STAR_SCHEMA.D_LINK_TYPE TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_C_RQRMNT_DOWNGAP_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_C_RQRMNT_UPCOVER_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_RQRMNT_DOWNGAP_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_RQRMNT_UPCOVER_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.H_RQRMNT_DOWNGAP_BYCOLL TO REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.H_RQRMNT_UPCOVER_BYCOLL TO REPUSER;
GRANT SELECT ON $STAR_SCHEMA.VW_RQRMNT_COVERAGE_LOOKUP TO REPUSER;

SET CURRENT SCHEMA $NF_SCHEMA;

CREATE TABLE PROJECT_MEMBER_LOOKUP(
		PROJECT_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL
);

CREATE TABLE TEAM_MEMBER_LOOKUP(
		TEAM_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL
);

CREATE TABLE TEAM_ROLE_MEMBER_LOOKUP (
		TEAM_ROLE_ID INTEGER NOT NULL,
		RESOURCE_ID INTEGER NOT NULL
);

ALTER TABLE TEAM ADD PARENT_TEAM_ID INTEGER DEFAULT -1 NOT NULL;

CREATE INDEX TEAR_IDX2 ON TEAM_ROLE (EXTERNAL_KEY2, EXTERNAL_ID);

ALTER TABLE PROJECT_MEMBER_LOOKUP ADD CONSTRAINT PRJMEM_PK PRIMARY KEY (PROJECT_ID, RESOURCE_ID);

ALTER TABLE TEAM_MEMBER_LOOKUP ADD CONSTRAINT TEAMMEM_PK PRIMARY KEY (TEAM_ID, RESOURCE_ID);

ALTER TABLE TEAM_ROLE_MEMBER_LOOKUP ADD CONSTRAINT TEAMROLELK_PK PRIMARY KEY (TEAM_ROLE_ID, RESOURCE_ID);

ALTER TABLE PROJECT_MEMBER_LOOKUP ADD CONSTRAINT PRJMEM_FK1 FOREIGN KEY (PROJECT_ID)
	REFERENCES PROJECT (PROJECT_ID);

ALTER TABLE PROJECT_MEMBER_LOOKUP ADD CONSTRAINT PRJMEM_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES RESOURCE (RESOURCE_ID);

ALTER TABLE TEAM_MEMBER_LOOKUP ADD CONSTRAINT TEAMMEM_FK1 FOREIGN KEY (TEAM_ID)
	REFERENCES TEAM (TEAM_ID);

ALTER TABLE TEAM_MEMBER_LOOKUP ADD CONSTRAINT TEAMMEM_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES RESOURCE (RESOURCE_ID);
	
ALTER TABLE TEAM_ROLE_MEMBER_LOOKUP ADD CONSTRAINT TEAMROLELK_FK1 FOREIGN KEY (TEAM_ROLE_ID)
	REFERENCES TEAM_ROLE (TEAM_ROLE_ID) ON DELETE CASCADE;

ALTER TABLE TEAM_ROLE_MEMBER_LOOKUP ADD CONSTRAINT TEAMROLELK_FK2 FOREIGN KEY (RESOURCE_ID)
	REFERENCES RESOURCE (RESOURCE_ID);
	
ALTER TABLE PROJECT_ROLE_MEMBER_LOOKUP DROP CONSTRAINT PRJROLELK_FK1;
ALTER TABLE PROJECT_ROLE_MEMBER_LOOKUP ADD CONSTRAINT PRJROLELK_FK1 FOREIGN KEY (PROJECT_ROLE_ID)
	REFERENCES PROJECT_ROLE (PROJECT_ROLE_ID) ON DELETE CASCADE;
	
ALTER TABLE TEAM ADD CONSTRAINT CMPTEAM_FK2 FOREIGN KEY (PARENT_TEAM_ID)
	REFERENCES TEAM (TEAM_ID);

CREATE TRIGGER TRG_PRJMEMD
	AFTER UPDATE OF REC_DATETIME ON PROJECT
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
BEGIN ATOMIC
    DELETE FROM PROJECT_MEMBER_LOOKUP WHERE PROJECT_ID=NEWROW.PROJECT_ID; END;
    
CREATE TRIGGER TRG_TEAMMEMD
	AFTER UPDATE OF REC_DATETIME ON TEAM
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
BEGIN ATOMIC
    DELETE FROM TEAM_MEMBER_LOOKUP WHERE TEAM_ID=NEWROW.TEAM_ID; END; 
    
CREATE TRIGGER TRG_TEAMROLED
	AFTER UPDATE OF REC_DATETIME ON TEAM
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
BEGIN ATOMIC
    DELETE FROM TEAM_ROLE WHERE TEAM_ID=NEWROW.TEAM_ID; END;
    
CREATE TRIGGER TRG_PRJROLED2
	AFTER UPDATE OF REC_DATETIME ON PROJECT
	REFERENCING  NEW AS NEWROW
		OLD AS OLDROW
	FOR EACH ROW MODE DB2SQL
	WHEN  (NEWROW.PROJECT_CLASS_ID NOT IN (SELECT PROJECT_CLASS_ID FROM PROJECT_CLASSIFICATION WHERE NAME = 'CQ Project'))
BEGIN ATOMIC
    DELETE FROM PROJECT_ROLE WHERE PROJECT_ID=NEWROW.PROJECT_ID; END;

DROP VIEW $STAR_SCHEMA.VW_TEAM;
CREATE VIEW $STAR_SCHEMA.VW_TEAM (EXTERNAL_ID, NAME, REFERENCE_ID, TEAM_ID,PROJECT_ID,PROJECT_NAME,PARENT_TEAM_ID, PARENT_TEAM_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT C.EXTERNAL_ID, C.NAME, C.REFERENCE_ID, C.TEAM_ID,C.PROJECT_ID,P.NAME AS PROJECT_NAME,C.PARENT_TEAM_ID, PT.NAME AS PARENT_TEAM_NAME,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.REC_DATETIME,C.ISSOFTDELETED
 FROM $NF_SCHEMA.TEAM C
 JOIN $NF_SCHEMA.PROJECT P ON P.PROJECT_ID=C.PROJECT_ID
 JOIN $NF_SCHEMA.TEAM PT ON C.PARENT_TEAM_ID=PT.TEAM_ID);

CREATE VIEW $STAR_SCHEMA.VW_TEAM_MEMBER_LOOKUP(TEAM_ID,TEAM_NAME,RESOURCE_ID,RESOURCE_NAME) AS
(SELECT TR.TEAM_ID,T.NAME AS TEAM_NAME,TR.RESOURCE_ID,R.FULL_NAME AS RESOURCE_NAME
FROM $NF_SCHEMA.TEAM_MEMBER_LOOKUP TR
JOIN $NF_SCHEMA.TEAM T ON T.TEAM_ID=TR.TEAM_ID
JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID=TR.RESOURCE_ID);

CREATE VIEW $STAR_SCHEMA.VW_TEAM_ROLE_MEMBER_LOOKUP(TEAM_ROLE_ID,TEAM_NAME,TEAM_ROLE_NAME,RESOURCE_ID,FULL_NAME) AS
(SELECT TRM.TEAM_ROLE_ID,T.NAME AS TEAM_NAME, TR.NAME AS TEAM_ROLE_NAME,TRM.RESOURCE_ID,R.FULL_NAME
FROM $NF_SCHEMA.TEAM_ROLE_MEMBER_LOOKUP TRM
JOIN $NF_SCHEMA.TEAM_ROLE TR ON TR.TEAM_ROLE_ID=TRM.TEAM_ROLE_ID
JOIN $NF_SCHEMA.TEAM T ON T.TEAM_ID=TR.TEAM_ID
JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID=TRM.RESOURCE_ID);

DROP VIEW $STAR_SCHEMA.VW_PROJECT_ROLE_MEMBER_LOOKUP;
CREATE VIEW $STAR_SCHEMA.VW_PROJECT_ROLE_MEMBER_LOOKUP(PROJECT_ROLE_ID,PROJECT_NAME,PROJECT_ROLE_NAME,RESOURCE_ID,FULL_NAME) AS
(SELECT PRM.PROJECT_ROLE_ID,P.NAME AS PROJECT_NAME,PR.NAME AS PROJECT_ROLE_NAME,PRM.RESOURCE_ID,R.FULL_NAME
FROM $NF_SCHEMA.PROJECT_ROLE_MEMBER_LOOKUP PRM
JOIN $NF_SCHEMA.PROJECT_ROLE PR ON PR.PROJECT_ROLE_ID=PRM.PROJECT_ROLE_ID
JOIN $NF_SCHEMA.PROJECT P ON P.PROJECT_ID=PR.PROJECT_ID
JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID=PRM.RESOURCE_ID);

CREATE VIEW $STAR_SCHEMA.VW_PROJECT_MEMBER_LOOKUP(PROJECT_ID,PROJECT_NAME,RESOURCE_ID,RESOURCE_NAME) AS
(SELECT PR.PROJECT_ID,P.NAME AS PROJECT_NAME,PR.RESOURCE_ID,R.FULL_NAME AS RESOURCE_NAME
FROM $NF_SCHEMA.PROJECT_MEMBER_LOOKUP PR
JOIN $NF_SCHEMA.PROJECT P ON P.PROJECT_ID=PR.PROJECT_ID
JOIN $NF_SCHEMA.RESOURCE R ON R.RESOURCE_ID=PR.RESOURCE_ID);

GRANT SELECT ON $STAR_SCHEMA.VW_PROJECT_ROLE_MEMBER_LOOKUP TO $REP_USER;
GRANT SELECT ON $STAR_SCHEMA.VW_PROJECT_MEMBER_LOOKUP TO $REP_USER;
GRANT SELECT ON $STAR_SCHEMA.VW_TEAM TO $REP_USER;
GRANT SELECT ON $STAR_SCHEMA.VW_TEAM_MEMBER_LOOKUP TO $REP_USER;
GRANT SELECT ON $STAR_SCHEMA.VW_TEAM_ROLE_MEMBER_LOOKUP TO $REP_USER;


SET CURRENT SCHEMA $CONFIG_SCHEMA;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.5' WHERE INFO_ID=6;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET CHAR_VALUE='2.0.5 S2',INT_VALUE=13 WHERE INFO_ID=18;
