<script>
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
/**
 * This function will resize the containing iFrame to fit the contents. The code
 * assumes that the iframe and its containing page are on the same domain; if
 * this turns out to be incorrect, we'll need to revisit this.
 */
function doResize() {	
	try {
		var parentIFrame = parent.document.getElementById(window.name);
		var bodyElement = document.body;
		
		//scrollHeight & scrollWidth do not include margins, so fetch that separately
		var totMarginVertical = 0;
		var totMarginHorizontal = 0;
		if(!window.getComputedStyle) {// IE < 9
	        totMarginVertical = parseInt(bodyElement.currentStyle.marginTop, 10) + parseInt(bodyElement.currentStyle.marginBottom, 10);
	        totMarginHorizontal = parseInt(bodyElement.currentStyle.marginLeft, 10) + parseInt(bodyElement.currentStyle.marginRight, 10);
	    } else {
	        totMarginHorizontal = parseInt(window.getComputedStyle(bodyElement).getPropertyValue('margin-left')) + parseInt(window.getComputedStyle(bodyElement).getPropertyValue('margin-right'));
	        totMarginVertical = parseInt(window.getComputedStyle(bodyElement).getPropertyValue('margin-top')) + parseInt(window.getComputedStyle(bodyElement).getPropertyValue('margin-bottom'))	;
	    }
		
		parentIFrame.style.height = bodyElement.scrollHeight + totMarginVertical + "px";;  
		parentIFrame.style.width = bodyElement.scrollWidth + totMarginHorizontal + "px";
	} catch (err){
		console.error("Could not resize prompt frame: "+err);
		//just pick a reasonable value for the height if anything goes wrong 
		parentIFrame.style.height = "600px";
		parentIFrame.style.width = "600px";
	}
}

/**
 * Edits the returned Cognos HTML to remove unnecessary/incompatible code and make other changes required
 * to host the prompt HTML inside of CLM.
 */
function editForm() {
	var fW = (typeof getFormWarpRequest == "function" ? getFormWarpRequest() : document.forms["formWarpRequest"]);

    //the HTML returned by Cognos sets a "base" attribute in the head that points to the Cognos server.  This is bad for
    //links whose href is set to "#", because clicking on them will send you to the Cognos server, instead of doing what was
    //intended, and staying put while performing the onclick.  The correct fix for this is really to stop the event propagation in the
    //link's onclick handler, but since we don't have access to that, we'll put this workaround in instead.
	var links = fW.getElementsByTagName("A");
	for (var i=0; i<links.length; i++) {         
		//use getAttribute instead of just href because getAttribute will give you back the raw value
		if (links[i].getAttribute('href') == "#") {
			links[i].href = 'javascript:void(0)';
		}
	}
}

editForm();
var bodyElement = document.body;
bodyElement.onload= function() {
	// we will call doResize() only after a small wait because in some cases,
	// the size of the contents of the iFrame hasn't fully stabilized when
	// onload is called.
	setTimeout(doResize, 500);
};
</script>