/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.authoring.web.common.ui.dialogs.GuidanceSelectionDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.dialogs.SelectionDialog"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.dialogs", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	var messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.dialogs", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var _WIDTH_IN_EM = 30;
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.dialogs.GuidanceSelectionDialog", //$NON-NLS-1$
 com.ibm.team.process.authoring.web.common.ui.internal.dialogs.SelectionDialog, {
    // summary:
	//		GuidanceSelectionDialog provides a dialog for selecting practice, practice element in the 
	//      process description for process guidance. There is a practice/practice element tree. 
	//      We need to pass the process description, then the GuidanceSelectionDialog will build practice tree
	//      for selection.
	//
	// parameters:
	//		scope: (String) the url of process area for constructing the resource link which will display 
	//                       in this dialog.
	//		(optional) selectedUrl: (String) the initial selection url of the selected practice or practice element.
	//
	// methods:
	//		onOK: the function is called after clicking OK, one can override this function to add his own behavior.
	//      getTopText: provide top text in the dialog.
	//
	// usage:
	//		 this.selectionDialog = new GuidanceSelectionDialog({
	//			scope: "https://localhost:9443/jazz/process/project-areas/_wSiF4s_uEeGeKcRB1ZnThg"
    //        	selectedUrl: "https://127.0.0.1:9444/jazz/process-authoring/practices/_vxZnZ8_xEeG4MJPllocT3Q", //url of practice or practice element
    //        	onOk: dojo.hitch(this, this.dialogOk, this._callback)
    //        });
		primaryTitle: messages.SelectionDialogPrimaryTitle,
		width: _WIDTH_IN_EM + "em", //$NON-NLS-1$
		showSectionTree: false,
		
		getTopText: function() {
			return messages.SelectionDialogTopText;
		}
	});
})();