/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2007,
 * 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportDownloads");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.app.ua.PageHoverHelp");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal",
		"ReportsManagementMessages");

(function() { // module container
	var PageHoverHelp = jazz.app.ua.PageHoverHelp;
	var ReportDownloads = dojo
			.declare(
					"com.ibm.team.reports.web.ui.internal.ReportDownloads",
					[ dijit._Widget, dijit._Templated ],
					{
						urlPrefix: net.jazz.ajax._contextRoot + "/",
						
						/* src to icon */
						__downloadIconSrc: null,

						templatePath : dojo.moduleUrl(
								"com.ibm.team.reports.web",
								"ui/internal/templates/ReportDownloads.html"),

						constructor : function() {
							this.messages = dojo.i18n.getLocalization(
									"com.ibm.team.reports.web.ui.internal",
									"ReportsManagementMessages");
							this.__downloadIconSrc = dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/images/download_co.gif");
							this._csPageHelpWidgets= [];
						},

						postCreate : function() {
							com.ibm.team.reports.web.ui.internal.ReportDownloads.superclass.postCreate
									.apply(this);
							this._xdcLink.href = this.urlPrefix + "service/com.ibm.team.reports.service.internal.IReportArtifactDownloadService?type=xdc";
							this._archiveLink.href = this.urlPrefix + "service/com.ibm.team.reports.service.internal.IReportArtifactDownloadService?type=archive";
							this._createContextSensitiveHelp();
						},
						
						_createContextSensitiveHelp: function() {
							dojo.empty(this.csHelpNode);
							this._createCSHWidget(ReportDownloads.CSH_DATA_REPORT_DOWNLOADS);
						},

						_createCSHWidget: function(uaKey) {
							var parms = {};
							parms.uaKey = uaKey;
							var pageHelp = new PageHoverHelp(parms);
							this.csHelpNode.appendChild(pageHelp.domNode);
							this._csPageHelpWidgets.push(pageHelp);
						},
					});
	ReportDownloads.CSH_DATA_REPORT_DOWNLOADS = "com.ibm.jazz.reports.web.cshelp.report_downloads";

})();
