/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_templates.ManageTemplates");//$NON-NLS-1$
	
	dojo.require("dojo.i18n");//$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dijit.form.SimpleTextarea"); //$NON-NLS-1$
	dojo.require("dijit.form.TextBox");//$NON-NLS-1$
	dojo.require("dijit.form.Button");//$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI");//$NON-NLS-1$
	
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.projectarea");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessUtils"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_templates.ImportTemplateDialog");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_templates.ExportTemplateProgressDialog");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_templates.ErrorTemplateActionHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.StyledTableItemList"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.TRToolbar"); //$NON-NLS-1$
	
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("jazz.ui.PaginationControl"); //$NON-NLS-1$
	dojo.require("jazz.core.RegistryFactory"); //$NON-NLS-1$
	dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
	
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$//$NON-NLS-2$
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var ImportTemplateDialog = com.ibm.team.process.web.ui.internal.admin.process_templates.ImportTemplateDialog;
	var ExportTemplateProgressDialog = com.ibm.team.process.web.ui.internal.admin.process_templates.ExportTemplateProgressDialog;
	var ErrorTemplateActionHandler = com.ibm.team.process.web.ui.internal.admin.process_templates.ErrorTemplateActionHandler;
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var UIHelper = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var ProcessUtils = com.ibm.team.process.web.common.internal.ProcessUtils;
	var MessageBox = jazz.ui.MessageBox;
	var RegistryFactory	= jazz.core.RegistryFactory;
	
	var STATUS_TYPES = MessageBox.STATUS_TYPES;
	var TEMPLATES_PER_PAGE = 20;
	//constants for ids of elements and dijits
	var NAME = "name";//$NON-NLS-1$
	var PROCESS_ID = "processId";//$NON-NLS-1$
	var SUMMARY = "summary";//$NON-NLS-1$
	var NAME_EDIT = "nameEdit";//$NON-NLS-1$
	var PROCESS_ID_EDIT = "processIdEdit";//$NON-NLS-1$
	var SUMMARY_EDIT = "summaryEdit";//$NON-NLS-1$
	var CHANGES_PENDING = "changesPending"; //$NON-NLS-1$
	
	var SERVICE_URI = dojo.baseUrl + "../../service/com.ibm.team.process.internal.service.web.IProcessDefinitionFileService/";//$NON-NLS-1$
	var PROCESS_TEMPLATE_ACTIONS_EXTENSIONPOINT_ID = "com.ibm.team.process.web.processTemplateActions"; //$NON-NLS-1$
	
	function setText(e, text){
		e.appendChild(document.createTextNode(text));
	}
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_templates.ManageTemplates", com.ibm.team.process.web.ui.internal.StyledTableItemList, { //$NON-NLS-1$
		constructor: function(args){
			this.templateActionExtensions = [];
			this.templateActionExtensionsLoaded = false;
			this.actionToolbars = [];
			this._toolbarButtons = [];
			this._saveButtons = {};
			this._cancelButtons = {};
			this._editRow = null;
			this.templateBeingEdited = null;
			this.navigationClickHandler = null;
			this._owningApplicationKey = args.owningApplicationKey;
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function(){
			this.collectTemplateActionExtensions();
			this.header = new MessageBox();
			this.messageArea.appendChild(this.header.domNode);
			setText(this.heading, this.messages.ManageTemplates_1);
			setText(this.description, this.messages.ManageTemplates_2);
			dojo.addClass(this.tableContents, ProcessConstants.CSSClass.TOOLBAR_TABLE);
			dojo.addClass(this.tableContents, "templateTable", true); //$NON-NLS-1$
			var columns = [];
			columns.push({
				label: this.messages.ManageTemplates_3,
				width: "25%", //$NON-NLS-1$
				sortable: false
			});
            columns.push({
            	label: this.messages.ManageTemplates_8,
 				width: "25%", //$NON-NLS-1$
           		sortable: false
            });
            columns.push({
            	label: this.messages.ManageTemplates_4,
           		sortable: false
            });
	       	columns.push({
            	label: this.messages.ManageTemplates_26,
																   // Work around for 127064 
           		className: ProcessConstants.CSSClass.ACTION_COLUMN + " action-column-larger", //$NON-NLS-1$
            	sortable: false
            });
			this.createTable({
				columns: columns
			});
			
			this.refreshButton = this.addLink("#", "", "com.ibm.team.repository.web/ui/internal/images/refresh16.gif", dojo.hitch(this, function() { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				this.refresh();		
			}), this.messages.ManageTemplates_40);
			
			this.importButton = this.addLink("#", this.messages.ManageTemplates_5, "com.ibm.team.process.web/ui/internal/admin/process_templates/images/import-template_co.gif", dojo.hitch(this, function(e){ //$NON-NLS-1$ //$NON-NLS-2$
				var dialog = new ImportTemplateDialog({
					owningApplicationKey: this._owningApplicationKey
				});
				this.connect(dialog, "onSuccess", "handleImportTemplateSuccess");//$NON-NLS-1$ //$NON-NLS-2$
			}));
			this.deployButton = this.addLink("#", this.messages.ManageTemplates_15, "com.ibm.team.process.web/ui/internal/admin/process_templates/images/deploy-process-template_co.gif", dojo.hitch(this, this.performDeployTemplates));//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		collectTemplateActionExtensions: function() {
			var extPt = RegistryFactory.getRegistry().getExtensionPoint(PROCESS_TEMPLATE_ACTIONS_EXTENSIONPOINT_ID);
			dojo.forEach(extPt.getExtensions(), dojo.hitch(this, function(extension) {
				var pluginNamespace = extension.getNamespace();
				dojo.forEach(extension.getConfigurationElements(), dojo.hitch(this, function(cfgElement) {
					if (cfgElement.getName() !== "action") { return; } //$NON-NLS-1$
					var pluginModule = cfgElement.getAttribute("module"); //$NON-NLS-1$
					var extData = {
						nameSpace: pluginNamespace,
						module: pluginModule ? pluginModule : pluginNamespace,
						tooltip: cfgElement.getAttribute("tooltip"), //$NON-NLS-1$
						icon: cfgElement.getAttribute("icon"), //$NON-NLS-1$
						handlerClass: cfgElement.getAttribute("handler") //$NON-NLS-1$
					};
					this.templateActionExtensions.push(extData);
				}));
			}));
		},
		
		show: function(args){
			this.refresh(args);
		},
		
		refresh: function(args){
			this.deployButton.setDisabled(true);
			this.importButton.setDisabled(true);
			this.clearState();
			var tr = document.createElement("tr"); //$NON-NLS-1$
			var td = document.createElement("td"); //$NON-NLS-1$
			td.colSpan = 2;
			td.appendChild(document.createTextNode(this.messages.ManageTemplates_6));
			tr.appendChild(td);
			this.tbody.appendChild(tr);
			if (!args || !args.pageNum) {
				this.queryPageNumber = 0;
			} else {
				var intPageNum = parseInt(args.pageNum, 10);
				this.queryPageNumber = intPageNum;
			}
			var queryArgs = {
				pageNum: this.queryPageNumber,
				pageSize: TEMPLATES_PER_PAGE,
				owningApplicationKey: this._owningApplicationKey
			};
			var errorHandler = "handleShowTemplatesError";//$NON-NLS-1$  
			if (args && args.error) {
				errorHandler = args.error;
			}
			var srh = new ServiceResponseHandler(this, "showTemplates", errorHandler); //$NON-NLS-1$  
			ProcessClient.getProcessDefinitions(queryArgs, srh);
		},
		
		reload: function(args){
			if (!this._confirmLoseEdits()) {
				return;
			}
			this._destroyEditDijits(this._templateBeingEdited);
			this._templateBeingEdited = null;
			this.refresh(args);
		},
		
		clearState: function(){
			dojox.xml.parser.removeChildren(this.tbody);
			this.header.hideMessage();
			this._destroyActionToolbars();
		},
		
		showTemplates: function(data){
			dojox.xml.parser.removeChildren(this.tbody);
			dojox.xml.parser.removeChildren(this.tableControls);
			this._destroyPager();			
			
			//assume we are going to enable the deploy button
			var isDeployButtonDisabled = false;
			var self = this;
			
			if (data && data.count > 0) {
				this._pager = this._createPager(data);
				this.tableControls.appendChild(this._pager.domNode);
				
				var sortedTemplates = data.elements.sort(function(a, b){
					var translatedNameA = self.getTranslatedProcessDefinitionName(a);
					var translatedNameB = self.getTranslatedProcessDefinitionName(b);
					return translatedNameA.toLowerCase().localeCompare(translatedNameB.toLowerCase());
				});
				for (var i = 0; i < sortedTemplates.length; i++) {
					this.createRowForTemplate(sortedTemplates[i]);
				}
			} else {
				var message;
				if (this.isDeployed === true) {
					message = this.messages.ManageTemplates_35;
					//don't enable the deploy button if there are no templates
					isDeployButtonDisabled = true;
				} else {
					message = this.messages.ManageTemplates_9;
				}
				
				this.header.showMessage({
					type: STATUS_TYPES.INFO,
					summary: message
				});
			}
			this.deployButton.setDisabled(isDeployButtonDisabled);
			this.importButton.setDisabled(false);
		},

		/**
		 * Creates a row for a specific template
		 * 
		 * @param {Object} datum The template data
		 * @returns {Object} The row to be added 
		 */
		createRowForTemplate: function(datum){
			var nameNode = document.createElement("div");//$NON-NLS-1$
			dojo.attr(nameNode, "id", datum.itemId + NAME);//$NON-NLS-1$
			dojo.attr(nameNode, NAME, datum.name);
			var nameText = this.getTranslatedProcessDefinitionName(datum);
			var nameTextNode = document.createTextNode(nameText);
			nameNode.appendChild(nameTextNode);
			
			var idNode = document.createElement("div");//$NON-NLS-1$
			dojo.attr(idNode, "id", datum.itemId + PROCESS_ID);//$NON-NLS-1$
			dojo.attr(idNode, PROCESS_ID, datum.processId);
			var idTextNode = document.createTextNode(datum.processId);
			idNode.appendChild(idTextNode);
			
			var descNode = document.createElement("div"); //$NON-NLS-1$
			dojo.attr(descNode, "id", datum.itemId + SUMMARY);//$NON-NLS-1$
			dojo.attr(descNode, SUMMARY, datum.summary);
			//IE does not show top of cell if it has no text, so set the text to
			//a space if the summary is empty.
			var translatedSummary = this.getTranslatedProcessDefinitionSummary(datum);
			var summaryText = translatedSummary ? translatedSummary : " "; //$NON-NLS-1$
			var summaryTextNode = document.createTextNode(summaryText);
			
			descNode.appendChild(summaryTextNode);
			
			//create the row and add the process and state id's so we can save
			//edits
			var trToolbar = new com.ibm.team.process.web.ui.internal.TRToolbar();
			this.actionToolbars.push(trToolbar);
			
			var exportAction = new jazz.ui.toolbar.Button({
				imgSrc : dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/export.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				title : dojo.string.substitute(this.messages.ManageTemplates_7, [nameText]),
				onClick : dojo.hitch(this, function (event) {
					dojo.stopEvent(event);
					if (!this._isEditInProgress()) {
						new ExportTemplateProgressDialog({
							serviceUrl: SERVICE_URI + ProcessUtils.normalizeFileName(this._getProcessId(datum.itemId))  + ".zip", //$NON-NLS-1$
							itemId: datum.itemId,
							applicationKey: this._owningApplicationKey
						});
					}
				})
			});
			this._toolbarButtons.push(exportAction);
			trToolbar.addChild(exportAction);
			
			var deleteAction = new jazz.ui.toolbar.Button({
				imgSrc : dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/delete_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				title : dojo.string.substitute(this.messages.ManageTemplates_17, [nameText]),
				onClick : dojo.hitch(this, function (event) {
					dojo.stopEvent(event);
					if (!this._isEditInProgress()) {
						this.handleDeleteTemplate(datum.itemId);
					}
				})
			});
			this._toolbarButtons.push(deleteAction);
			trToolbar.addChild(deleteAction);
			
			var editAction = new jazz.ui.toolbar.Button({
				imgSrc : dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/edit.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				title : dojo.string.substitute(this.messages.ManageTemplates_36, [nameText]),
				onClick : dojo.hitch(this, function (event) {
					dojo.stopEvent(event);
					if (!this._isEditInProgress()) {
						this._showTemplateEditor(datum.itemId);
					}
				})
			});
			this._toolbarButtons.push(editAction);
			trToolbar.addChild(editAction);

			// add customized action buttons
			this._addCustomActionButtons(trToolbar, datum);
			
			var row = this.addRow(null, [nameNode, idNode, descNode, trToolbar.domNode]);
			dojo.attr(row, "processItemId", datum.itemId);//$NON-NLS-1$
			dojo.attr(row, "stateId", datum.stateId); //$NON-NLS-1$
			return row;
		},
		
		_doAddCustomActionButtons: function(trToolbar, datum) {
			for (var id = 0; id < this.templateActionExtensions.length; id++) {
				this._addCustomActionButton(trToolbar, datum, this.templateActionExtensions[id]);
			}				
		},
		
		_addCustomActionButtons: function(trToolbar, datum) {
			if (this.templateActionExtensionsLoaded) {
				this._doAddCustomActionButtons(trToolbar, datum);
			} else {
				this._loadActionHandler(0, dojo.hitch(this, function() {
					this._doAddCustomActionButtons(trToolbar, datum);
				}));
			}
		},
		
		_loadActionHandler: function(currentIndex, callback) {
			if(currentIndex < this.templateActionExtensions.length) {
				var currentExtension = this.templateActionExtensions[currentIndex];
				jazz.core.loader.load_async(currentExtension.handlerClass, dojo.hitch(this, function() {
					currentExtension.handlerConstructor = dojo.getObject(currentExtension.handlerClass);
					if (!currentExtension.handlerConstructor) {
						currentExtension.loadErrorMessage = dojo.string.substitute(this.messages.ManageTemplates_39, [currentExtension.handlerClass, currentExtension.nameSpace]);
					}
					this._loadActionHandler(currentIndex + 1, callback);
				}));
			} else {
				this.templateActionExtensionsLoaded = true;
				callback();
			}
		},
		
		_addCustomActionButton: function(trToolbar, datum, extData) {
			var handler = this._createLoadedActionHandler(extData);
			this._doAddCustomActionButton(extData.module, extData.icon, extData.tooltip, handler, trToolbar, datum);
		},
		
		_createLoadedActionHandler: function(extension) {
			var handler;
			if (extension.handlerConstructor) {
				// handler is successfully loaded
				try {
					handler = new extension.handlerConstructor();
				} catch (error) {
					handler = new ErrorTemplateActionHandler({
						errorMessage: error.message
					});
				}
			} else if (extension.loadErrorMessage) {
				// handler loading failed
				handler = new ErrorTemplateActionHandler({
					errorMessage: extension.loadErrorMessage
				});
			}
			return handler;
		},
		
		_doAddCustomActionButton: function(module, icon, tooltip, handler, trToolbar, datum) {
			var itemId = datum.itemId;
			
			handler.setItemId(itemId);
			var customAction = new jazz.ui.toolbar.Button({
				imgSrc : dojo.moduleUrl(module, icon),
				title : tooltip, 
				onClick : dojo.hitch(this, function () {
					var itemName = dojo.byId(handler.itemId + NAME).innerHTML;
					handler.setItemName(itemName);
					handler.doAction();
				})
			});
			this._toolbarButtons.push(customAction);
			trToolbar.addChild(customAction);
		},
				
		_isEditInProgress: function(){
			return this.templateBeingEdited;
		},
		
		/**
		 * Makes a process template in the table editable
		 * 
		 * @private
		 * @param {String} processItemId Item ID of the template to edit
		 */
		_showTemplateEditor: function(processItemId){
			this._disableToolbars(true);
			this._pager.setEnabled(false);
			this.importButton.setDisabled(true);
			this.deployButton.setDisabled(true);
			
			//set the global flag to prevent editing others
			this.templateBeingEdited = processItemId;
			
			//hide the old row
			var row = this._getRowForItemId(processItemId);
			var stateId = dojo.attr(row, "stateId"); //$NON-NLS-1$
			dojo.addClass(row, "hidden");//$NON-NLS-1$
			//register a click handler in case user leaves page
			this.bodyClickHandler = PlatformUI.getWorkbench().registerBodyClickHandler(dojo.hitch(this, this._handleNavigate), /*priority*/ 10000);
			this.onBeforeUnloadHandler = PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(dojo.hitch(this, this._navigateAwayEvent), /*priority*/ 10000);
			
			//create the new row 
			this._editRow = row.parentNode.insertRow(row.sectionRowIndex);
			dojo.attr(this._editRow, "data-ProcessItemId", processItemId); //$NON-NLS-1$
			dojo.addClass(this._editRow, "editing"); //$NON-NLS-1$
			//make name column
			var nameColumn = this._editRow.insertCell(0);
			
			var nameInputDiv = document.createElement("div");//$NON-NLS-1$
			nameColumn.appendChild(nameInputDiv);
			
			var nameDivNode = dojo.byId(processItemId + NAME);
			dojo.attr(nameDivNode, CHANGES_PENDING, false);
			var name = dojo.attr(nameDivNode, NAME);
			var self = this;
			
			var nameTextBox = new dijit.form.TextBox({
				id: processItemId + NAME_EDIT,
				value: name,
				intermediateChanges: true,
				onChange: function(newText){
					if (newText != name) {
						self._enableSaveButton(processItemId);
						dojo.attr(nameDivNode, CHANGES_PENDING, true);
					} else {
						if (!self._changesPending(SUMMARY, processItemId) && !self._changesPending(PROCESS_ID, processItemId)) {
							self._disableSaveButton(processItemId);
						}
						dojo.attr(nameDivNode, CHANGES_PENDING, false);
					}
				}
			}, nameInputDiv);
			nameTextBox.startup();
			
			//make ID column
			var idDivNode = dojo.byId(processItemId + PROCESS_ID);
			dojo.attr(idDivNode, CHANGES_PENDING, false);
			var id = dojo.attr(idDivNode, PROCESS_ID);
			
			var idColumn = this._editRow.insertCell(1);
			var idInputDiv = document.createElement("div");//$NON-NLS-1$
			idColumn.appendChild(idInputDiv);
			
			var idDivNode = dojo.byId(processItemId + PROCESS_ID);
			dojo.attr(idDivNode, CHANGES_PENDING, false); 
			var id = dojo.attr(idDivNode, PROCESS_ID);
			var idTextBox = new dijit.form.TextBox({
				id: processItemId + PROCESS_ID_EDIT,
				value: id,
				intermediateChanges: true,
				onChange: function(newText){
					if (newText != id) {
						self._enableSaveButton(processItemId);
						dojo.attr(idDivNode, CHANGES_PENDING, true);
					} else {
						if (!self._changesPending(SUMMARY, processItemId) && !self._changesPending(NAME, processItemId)) {
							self._disableSaveButton(processItemId);
						}
						dojo.attr(idDivNode, CHANGES_PENDING, false);
					}
				}
			}, idInputDiv);
			idTextBox.startup();
			
			//make summary column
			var summaryDivNode = dojo.byId(processItemId + SUMMARY);
			dojo.attr(summaryDivNode, CHANGES_PENDING, false);
			var summary = dojo.attr(summaryDivNode, SUMMARY);
			
			var summaryColumn = this._editRow.insertCell(2);
			var summaryInputDiv = document.createElement("div");//$NON-NLS-1$
			summaryColumn.appendChild(summaryInputDiv);
			
			var summaryTextarea = new dijit.form.SimpleTextarea({
				id: processItemId + SUMMARY_EDIT,
				value: summary,
				intermediateChanges: true,
				rows: dojo.isFF ? 2 : 3,
				onChange: function(newText){
					if (summary) {
						summary = dojo.string.trim(summary);
					}
					if (newText != summary) {
						self._enableSaveButton(processItemId);
						dojo.attr(summaryDivNode, CHANGES_PENDING, true);
					} else {
						if (!self._changesPending(PROCESS_ID, processItemId) && !self._changesPending(NAME, processItemId)) {
							self._disableSaveButton(processItemId);
						}
						dojo.attr(summaryDivNode, CHANGES_PENDING, false);
					}
				}
			}, summaryInputDiv);
			summaryTextarea.startup();
			
			//make buttons in actions column
			var iconColumn = this._editRow.insertCell(3);
			
			var saveParameters = {
				processItemId: processItemId,
				stateId: stateId,
				disabled: true
			};
			var saveButton = document.createElement("button"); //$NON-NLS-1$
			dojo.mixin(saveButton, saveParameters);
			saveButton.appendChild(document.createTextNode(this.messages.ManageTemplates_29));
			this.connect(saveButton, "onclick", this._handleSaveEdit); //$NON-NLS-1$
			iconColumn.appendChild(saveButton);
			this._saveButtons[processItemId] = saveButton;
			
			var cancelParameters = {
				processItemId: processItemId
			};
			var cancelButton = document.createElement("button");//$NON-NLS-1$
			cancelButton.appendChild(document.createTextNode(this.messages.ManageTemplates_28));
			dojo.mixin(cancelButton, cancelParameters);
			iconColumn.appendChild(cancelButton);
			this.connect(cancelButton, "onclick", this._handleCancelEdit); //$NON-NLS-1$
			this._cancelButtons[processItemId] = cancelButton;
			
			UIHelper.resizeI18NButtons(cancelButton, [cancelButton, saveButton]);
			
		},
		_changesPending: function (fieldId, processItemId) {
			var node = dojo.byId(processItemId + fieldId);
			if (node) {
				return dojo.attr(node, CHANGES_PENDING);
			}
			return false;
		},
		/**
		 * Dispose of the edit controls and show the regular row for
		 * the template being edited.
		 * @param {Object} event
		 */
		_handleCancelEdit: function(event){
			this.header.hideMessage();
			
			dojo.stopEvent(event);
			this.templateBeingEdited = null;
			var dij = event.target;
			var itemId = dij.processItemId;
			var hiddenRow = this._getRowForItemId(itemId);
			if (hiddenRow) {
				dojo.removeClass(hiddenRow, "hidden");//$NON-NLS-1$
			}
			this._destroyEditRow(itemId);
			this.importButton.setDisabled(false);
			this.deployButton.setDisabled(false);
			this._disableToolbars(false);
			this._pager.setEnabled(true);
		},
		
		/**
		 * Handles the save button being pressed
		 * 
		 * @private
		 * @param {Object} event The event object
		 */
		_handleSaveEdit: function(event){
			dojo.stopEvent(event);
			
			var dij = event.target;
			
			var itemId = dij.processItemId;
			var stateId = dij.stateId;
			var nameEdit = dijit.byId(itemId + NAME_EDIT);
			var processIdEdit = dijit.byId(itemId + PROCESS_ID_EDIT);
			var summaryEdit = dijit.byId(itemId + SUMMARY_EDIT);
			var newName = nameEdit.get('value'); //$NON-NLS-1$
			var newProcessId = processIdEdit.get('value'); //$NON-NLS-1$
			var newSummary = summaryEdit.get('value'); //$NON-NLS-1$
			if (this._validateSave(newName, newProcessId)) {
				var row = this._getRowForItemId(itemId);
				dojo.addClass(row, "updating"); //$NON-NLS-1$
				nameEdit.readOnly = true;
				processIdEdit.readOnly = true;
				summaryEdit.readOnly = true;
				this._disableCancelButton(itemId);
				this._disableSaveButton(itemId);
				this.performSaveEdit(itemId, stateId, newName, newProcessId, newSummary);
			}
		},
		
		_createTextNode: function(text) {
			if (dojo.isIE && text !== undefined && text.length === 0) {
				return document.createTextNode(" "); //$NON-NLS-1$
			}	
			return document.createTextNode(text);		
		},
		
		_validateSave: function(name, processId){
			if (!name || name === "") {//$NON-NLS-1$
				this.header.showMessage({
					type: STATUS_TYPES.ERROR,
					summary: this.messages.ManageTemplates_32
				});
				return false;
			}
			if (!processId || processId === "") {//$NON-NLS-1$
				this.header.showMessage({
					type: STATUS_TYPES.ERROR,
					summary: this.messages.ManageTemplates_33
				});
				return false;
			}
			return true;
		},
		_handleNavigate: function(href){
			var navigateTo = href.fragment;
			if (!navigateTo) {
				navigateTo = href.uri;
			}
			if (navigateTo.indexOf("IProcessDefinitionFileService") === -1 && navigateTo.indexOf("ProcessTemplateManagement") === -1) {//$NON-NLS-1$ //$NON-NLS-2$            
				//if user editing, prompt to save
				if (this._isEditInProgress()) {
					if (confirm(this.messages.ManageTemplates_30)) {
						//user pressed OK to laeave page
						this._unregisterClickHandlers();
						this._destroyEditDijits(this.templateBeingEdited);
						this.templateBeingEdited = null;
						return false;
					} else {
						//veto the navigation
						return true;
					}
				}
			}
			//let the navigation continue (don't veto it) if it is not to another page.
			return false;
		},
		_navigateAwayEvent: function(){
			if (this._isEditInProgress()) {
				return this.messages.ManageTemplates_31;
			}
			
			return false;
		},
		/**
		 * Remove the row from its table and destroy any edit dijits for the
		 * item with given itemId
		 * 
		 * @private
		 * @param {Object} itemId The itemId of the process template that the
		 * row was editing
		 */
		_destroyEditRow: function(itemId){
			this._unregisterClickHandlers();
			this._editRow.parentNode.removeChild(this._editRow);
			this._editRow = null;
			this._destroyEditDijits(itemId);
		},
		_unregisterClickHandlers: function(){
			if (this.bodyClickHandler) {
				PlatformUI.getWorkbench().unregisterBodyClickHandler(this.bodyClickHandler);
			}
			if (this.onBeforeUnloadHandler) {
				PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandler);
			}
		},
		_destroyEditDijits: function(itemId){
			var nameDijit = dijit.byId(itemId + NAME_EDIT);
			if (nameDijit) {
				nameDijit.destroyRecursive();
			}
			
			var idDijit = dijit.byId(itemId + PROCESS_ID_EDIT);
			if (idDijit) {
				idDijit.destroyRecursive();
			}
			
			var summaryDijit = dijit.byId(itemId + SUMMARY_EDIT);
			if (summaryDijit) {
				summaryDijit.destroyRecursive();
			}
			
		},
		_enableSaveButton: function(itemId){
			var theButton = this._saveButtons[itemId];
			if (theButton) {
				theButton.disabled = false;
			}
		},
		_disableSaveButton: function(itemId){
			var theButton = this._saveButtons[itemId];
			if (theButton) {
				theButton.disabled = true;
			}
		},
		_enableCancelButton: function(itemId){
			var theButton = this._cancelButtons[itemId];
			if (theButton) {
				theButton.disabled = false;
			}
		},
		_disableCancelButton: function(itemId){
			var theButton = this._cancelButtons[itemId];
			if (theButton) {
				theButton.disabled = true;
			}
		},
		handleImportTemplateSuccess: function(){
			this.refresh({
				pageNum: this.queryPageNumber
			});
		},
		handleDeleteTemplate: function(processItemId){
			var processName = this._getProcessName(processItemId);
			var msg = dojo.string.substitute(this.messages.ImportTemplateDialog_9,[processName]);
			if (confirm(msg)) {
				this.header.showMessage({
					type: STATUS_TYPES.INFO,
					summary: this.messages.ImportTemplateDialog_10
				});
				var srh = new ServiceResponseHandler(this, "handleDeleteTemplateSuccess", "handleDeleteTemplateError"); //$NON-NLS-1$ //$NON-NLS-2$
				ProcessClient.deleteProcessDefinition({
					uuid: processItemId
				}, srh);
			}
		},
		
		handleDeleteTemplateSuccess: function(processDefinitionDTO){
			this.refresh({
				pageNum: this.queryPageNumber,
				error: "handleRefreshAfterDeleteError" //$NON-NLS-1$
			});
		},
		
		handleRefreshAfterDeleteError: function(error){
			//if the refresh fails because the number of templates in the repository is insufficient to warrant the
			//page, show the previous page of the query instead.
			if (this.queryPageNumber !== 0) {
				this.queryPageNumber--;
			}
			window.location.hash = "#action=" + ProcessConstants.PREFIX + "manageTemplates&pageNum=" + this.queryPageNumber; //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		handleDeleteTemplateError: function(error){
			// Error class and exception call stack add no value to user
			delete error.errorClass;
			delete error.exception;
			
			this.header.showMessage({
				type: STATUS_TYPES.ERROR,
				summary: this.messages.ManageTemplates_16,
				errorObject: error
			});
		},
		/**
		 * Handles an edit being saved
		 * 
		 * @param itemId
		 * @param stateId
		 * @param newName
		 * @param newProcessId
		 * @param newSummary
		 */
		performSaveEdit: function(itemId, stateId, newName, newProcessId, newSummary){
			var msg = document.createElement("div");//$NON-NLS-1$
			msg.appendChild(document.createTextNode(dojo.string.substitute(this.messages.ManageTemplates_27, [newProcessId])));
			this.header.showMessage({
				type: STATUS_TYPES.INFO,
				summary: msg
			});
			
			var srh = new ServiceResponseHandler(this, "handleSaveEditSuccess", "handleSaveEditError"); //$NON-NLS-1$ //$NON-NLS-2$
			var args = {
				itemId: itemId,
				stateId: stateId,
				name: newName,
				id: newProcessId,
				summary: newSummary
			};
			
			ProcessClient.postProcessDefinition(args, srh);
			
		},
		/**
		 * prompts user and cleans up state and dijits if appropriate
		 * 
		 * @returns {Boolean}
		 */
		_confirmLoseEdits: function(){
			if (this._isEditInProgress()) {
				if (!confirm(this.messages.ManageTemplates_34)) {
					//user does not want to continue deploying
					return false;
				} else {
					//reset template edit -- edits will be overwritten when 
					//deploy runs
					this._destroyEditDijits(this.templateBeingEdited);
					this._unregisterClickHandlers();
					this.templateBeingEdited = null;
					return true;
				}
			}
			return true;
		},
		/**
		 * Deploy templates and update the table.
		 * 
		 * @param e
		 * @returns {Boolean}
		 */
		performDeployTemplates: function(e){
			dojo.stopEvent(e);
			if (e.target.disabled) {
				return;
			}
			if (!this._confirmLoseEdits()) {
				return false;
			}
			//warn user that current templates may be overwritten
            if (!confirm(this.messages.ManageTemplates_37)) {
            	//user pressed CANCEL
            	return false;
            }
			this.deployButton.setDisabled(true);
			this.importButton.setDisabled(true);
			dojox.xml.parser.removeChildren(this.tbody);
			this.header.showMessage({
				type: STATUS_TYPES.INFO,
				summary: this.messages.ManageTemplates_13
			});
			var srh = new ServiceResponseHandler(this, "handleDeployTemplateSuccess", "handleDeployTemplateError"); //$NON-NLS-1$ //$NON-NLS-2$
			var queryArgs = {
				owningApplicationKey: this._owningApplicationKey
			};
			ProcessClient.deployPredefinedProcessDefinitions(queryArgs, srh);
		},
		/**
		 * Handles when the save button is pressed and the save was successful
		 * 
		 * @private
		 * @param response
		 */
		handleSaveEditSuccess: function(response){
			this.header.hideMessage();
			this.templateBeingEdited = null;
			this.handleEditedProcess(response);
		},
		
		/**
		 * Handles when the save button is pressed and an error occurs
		 * 
		 * @private
		 * @param error
		 */
		handleSaveEditError: function(error){
			this.templateBeingEdited = dojo.attr(this._editRow, "data-ProcessItemId"); //$NON-NLS-1$
			this.handleEditedProcessFailed(this.templateBeingEdited);
			this.handleTemplateError(this.messages.ManageTemplates_25, error.message, false, false);
		},
		
		handleDeployTemplateSuccess: function(){
			this.isDeployed = true;
			this.refresh();
		},
		
		handleShowTemplatesError: function(error){
			var title = this.messages.ManageTemplates_18;
			this.handleTemplateError(title, error.message, true, false);
		},
		
		handleDeployTemplateError: function(error){
			var title = this.messages.ManageTemplates_14;
			this.handleTemplateError(title, error.message, true, error.errorClass.indexOf("TeamOperationCanceledException") !== -1);//$NON-NLS-1$
		},
		
		handleCustomizeActionError: function(error) {
			var title = this.messages.ManageTemplates_38;
			dojo.publish(net.jazz.ajax.internal.events.viewErrorPage, [title, error.message]);
		},
		
		handleTemplateError: function(errorTitle, errorMessage, isBodyRemoved, shouldShowTemplates){
			if (isBodyRemoved) {
				dojox.xml.parser.removeChildren(this.tbody);
			}
			//remove the "Pending.." message
			this.header.hideMessage();
			
			//show the error
			var msg = {
				type: STATUS_TYPES.ERROR,
				summary: errorTitle
			};
			if (errorMessage) {
                msg.details = [{
                	message: errorMessage,
                	code: STATUS_TYPES.ERROR
                }];
			}
			this.header.showMessage(msg);
			this.deployButton.setDisabled(false);
			this.importButton.setDisabled(false);
			if (shouldShowTemplates) {
				this.queryPageNumber = 0;
				var queryArgs = {
					pageNum: this.queryPageNumber,
					pageSize: TEMPLATES_PER_PAGE
				};
				
				var srh = new ServiceResponseHandler(this, "showTemplates", "nullErrorHandler"); //$NON-NLS-1$  //$NON-NLS-2$
				ProcessClient.getProcessDefinitions(queryArgs, srh);
			}
		},
		
		nullErrorHandler: function(){
			//intentionally empty.  Do not overwrite an existing error message
			//with latest failure.
		},
		
		getTranslatedProcessDefinitionName: function(definition){
			var translatedName;
			
            if (djConfig.locale && definition.supportedLocales && definition.supportedLocales.length > 0) {
				// try the client locale next
				var locale = djConfig.locale;
                var localeIndex = dojo.indexOf(definition.supportedLocales, locale);
                if (localeIndex !== -1) {
                	translatedName = definition.translatedNames[localeIndex];
                }
				
                
                if (!translatedName) {
                	// if the locale included more than the language code, look for the generic
                	// language locale first
                	if (locale.length > 2) {
                		var locale = locale.substring(0, 2);
                		if (dojo.indexOf(definition.supportedLocales, locale) !== -1) {
                			translatedName = definition.translatedNames[dojo.indexOf(definition.supportedLocales, locale)];
                		}
                	}
                	
                	// try any supported locales with the same language code
                	for (var i = 0; !translatedName && i < definition.supportedLocales.length; i++) {
                		if (definition.supportedLocales[i].indexOf(locale) === 0) {
                			var supportedLocale = definition.supportedLocales[i];
                			if (dojo.indexOf(definition.supportedLocales, supportedLocale) !== -1) {
                				translatedName = definition.translatedNames[dojo.indexOf(definition.supportedLocales, supportedLocale)];
                			}
                		}
                	}
                }
            }
			
			// next try the default locale for the process definition
			if (!translatedName) {
				translatedName = definition.defaultName;
			}
			
			// finally default to the untranslated value
			if (!translatedName) {
				translatedName = definition.name;
			}
			
			return translatedName;
		},
		
		getTranslatedProcessDefinitionSummary: function(definition){
			var translatedSummary;
			
            if (djConfig.locale && definition.supportedLocales && definition.supportedLocales.length > 0) {
				// try the client locale next
				var locale = djConfig.locale;
                var localeIndex = dojo.indexOf(definition.supportedLocales, locale);
                if (localeIndex !== -1) {
                	translatedSummary = definition.translatedSummaries[localeIndex];
                }
				
                if (!translatedSummary) {
                	// if the locale included more than the language code, look for the generic
                	// language locale first
                	if (locale.length > 2) {
                		var locale = locale.substring(0, 2);
                		if (dojo.indexOf(definition.supportedLocales, locale) !== -1) {
                			translatedSummary = definition.translatedSummaries[dojo.indexOf(definition.supportedLocales, locale)];
                		}
                	}
                	
                	// try any supported locales with the same language code
                	for (var i = 0; !translatedSummary && i < definition.supportedLocales.length; i++) {
                		if (definition.supportedLocales[i].indexOf(locale) === 0) {
                			var supportedLocale = definition.supportedLocales[i];
                			if (dojo.indexOf(definition.supportedLocales, supportedLocale) !== -1) {
                				translatedSummary = definition.translatedSummaries[dojo.indexOf(definition.supportedLocales, supportedLocale)];
                			}
                		}
                	}
                }
            }
			
			// next try the default locale for the process definition
			if (!translatedSummary) {
				translatedSummary = definition.defaultSummary;
			}
			
			// finally default to the untranslated value
			if (!translatedSummary) {
				translatedSummary = definition.summary;
			}
			
			return translatedSummary;
		},
		
		/**
		 * Update the row for the given process template with the new fields
		 * values.
		 *
		 * @param {ProcessDefinitionDTO} processDefinitionDto
		 */
		handleEditedProcess: function(processDefinitionDto){			
			var itemId = processDefinitionDto.itemId;
			var stateId = processDefinitionDto.stateId;
			var newName = processDefinitionDto.name;
			var newProcessId = processDefinitionDto.processId;
			var newSummary = processDefinitionDto.summary;
			var row = this._getRowForItemId(itemId);
			dojo.attr(row, "stateId", stateId);//$NON-NLS-1$
			
			var nameNode = dojo.byId(itemId + NAME);
			var changesPending = dojo.attr(nameNode, CHANGES_PENDING);
			if (changesPending === true) {
				dojo.attr(nameNode, NAME, newName);
				dojo.empty(nameNode);
				nameNode.appendChild(document.createTextNode(this.getTranslatedProcessDefinitionName(processDefinitionDto)));
			}
			var idNode = dojo.byId(itemId + PROCESS_ID);
			changesPending = dojo.attr(idNode, CHANGES_PENDING);
			if (changesPending === true) {
				dojo.attr(idNode, PROCESS_ID, newProcessId);
				dojo.empty(idNode);
				idNode.appendChild(document.createTextNode(newProcessId));
			}
			var summaryNode = dojo.byId(itemId + SUMMARY);
			changesPending = dojo.attr(summaryNode, CHANGES_PENDING);
			if (changesPending === true) {
				dojo.attr(summaryNode, SUMMARY, newSummary);
				dojo.empty(summaryNode);
				summaryNode.appendChild(document.createTextNode(this.getTranslatedProcessDefinitionSummary(processDefinitionDto)));
			}
			
			dojo.removeClass(row, "updating");//$NON-NLS-1$
			dojo.removeClass(row, "hidden");//$NON-NLS-1$
			this._destroyEditRow(itemId);
			this.importButton.setDisabled(false);
			this.deployButton.setDisabled(false);
			this._disableToolbars(false);
			this._pager.setEnabled(true);
		},
		
		/**
		 * 
		 * 
		 * @param itemId The itemId of the row
		 */
		handleEditedProcessFailed: function(itemId){
			var nameEdit = dijit.byId(itemId + NAME_EDIT);
			var processIdEdit = dijit.byId(itemId + PROCESS_ID_EDIT);
			var summaryEdit = dijit.byId(itemId + SUMMARY_EDIT);
		
			nameEdit.readOnly = false;
			processIdEdit.readOnly = false;
			summaryEdit.readOnly = false;
			this._enableCancelButton(itemId);
			this._enableSaveButton(itemId);
			
			var row = this._getRowForItemId(itemId);
			dojo.removeClass(row, "updating");//$NON-NLS-1$
		},
		
		_createPager: function(data) {
			return new jazz.ui.PaginationControl({
						total: data.count,
						increment: TEMPLATES_PER_PAGE,
						startPage: this.queryPageNumber,
						onNextClick: dojo.hitch(this, function(pager, start, end){
							if (end === pager.total) {
								this.queryPageNumber = Math.ceil(pager.total / pager.increment) - 1;
							} else {
								this.queryPageNumber++;
							}
							this.refresh({
								pageNum: this.queryPageNumber
							});
						}),
						onPreviousClick: dojo.hitch(this, function(pager, start, end){
							if (start === 1) {
								this.queryPageNumber = 0;
							} else {
								this.queryPageNumber--;
							}
							this.refresh({
								pageNum: this.queryPageNumber
							});
						})
					});
		},
		
		/**
		 * Find the row element that encloses the element that caused the event.
		 * 
		 * @private
		 * @param {Object} Event
		 * @returns {Object} The row, otherwise null
		 */
		_getRow: function(evt){
			var e = evt.target;
			while (e.parentNode) {
				if (e.tagName === "TR") { //$NON-NLS-1$
					return e;
				}
				e = e.parentNode;
			}
			return null;
		},
		
		/**
		 * Find the row for a given item id
		 * 
		 * @private
		 * @param {String} itemId Template ID
		 * @returns {Object} The row with the ID, otherwise null
		 */
		_getRowForItemId: function(itemId){
			var foundRows = dojo.query("tr[processItemId='" + itemId + "']");//$NON-NLS-1$ //$NON-NLS-2$
			if (foundRows.length > 0) {
				return foundRows[0];
			}
			return null;
		},

		_getProcessId: function(itemId){
			var processIdNode = dojo.byId(itemId + PROCESS_ID);
			return dojo.attr(processIdNode, PROCESS_ID);
		},
		
		_getProcessName: function(itemId) {
			var processNameNode = dojo.byId(itemId + NAME);
			var processName = ""; //$NON-NLS-1$
			if (processNameNode.firstChild) { 
				processName = dojo.string.trim(processNameNode.firstChild.nodeValue);
			} else {
				processName = dojo.attr(processNameNode, NAME); 
			}
			return processName;
		},

		_disableToolbars: function(disabled){
			for (var i = 0; i < this.actionToolbars.length; i++) {
				this.actionToolbars[i].disableToolbar(disabled);
			}
		},
		
		_destoryToolbarButtons: function() {
			for (var i = 0; i < this._toolbarButtons.length; i++) {
				if (this._toolbarButtons[i]) {
					this._toolbarButtons[i].destroyRecursive();
				}
			}
			this._toolbarButtons = [];
		},
		
		_destroyActionToolbars: function(){
			this._destoryToolbarButtons();
			for (var i = 0; i < this.actionToolbars.length; i++) {
				if (this.actionToolbars[i]) {
					this.actionToolbars[i].destroyRecursive();
				}
			}
			this.actionToolbars = [];
		},
		
		_destroyPager: function() {
            if (this._pager) {
            	this._pager.destroyRecursive();
            	delete this._pager;
            }

		},
		
		uninitialize: function(){
			this._destroyActionToolbars();
			this._destroyPager();
			this.header.destroyRecursive();
						
			this.inherited(arguments);
		}
	});
	
})();
