/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_templates.ProcessTemplateManagementMenu"); //$NON-NLS-1$
	dojo.require("jazz.app._ComponentMenu"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("jazz.util.html"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$//$NON-NLS-2$
	var _ComponentMenu = jazz.app._ComponentMenu;
	var messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_templates.ProcessTemplateManagementMenu", _ComponentMenu, { //$NON-NLS-1$
		
		constructor: function() {
			this._insertIndex = 0;
		},
		
		postCreate: function() {
			this.refresh();
		},
		
		refresh: function() {
			this.clear();
			this._addManageTemplatesSection();
		},
		
		/**
		 * Get the current selected menu item
		 */
		getSelected: function() {
	    	var currentHref = window.location.href;
			var items = this.getItems();
			for (var i in items) {
			    if (currentHref.indexOf(items[i].href) > -1) {
				    return items[i];
				}
			}
			return null;
		},
		
		/**
		 * Add Manage Process Templates menu item under Manage category 
		 */
		_addManageTemplatesSection: function() {
			
			this.addTitle(this._escape(messages.ProcessTemplateManagementMenu_ManageTemplateTitle), this._insertIndex++);
			
			var menuItem = {};
			menuItem.icon = String(dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/process_templates/images/processtemplate_obj.gif")); //$NON-NLS-1$ //$NON-NLS-2$
			menuItem.label = this._escape(messages.ProcessTemplateManagementMenu_ManageTemplates);
			menuItem.href = "#action=com.ibm.team.process.manageTemplates"; //$NON-NLS-1$
			menuItem.insertIndex = this._insertIndex++;
			this.addItemByArgs(menuItem);
		},
		
		/**
		 * Escape the special html characters in the text
		 * @param {String} text
		 */
		_escape: function(text) {
			return jazz.util.html.escape(text);
		}
		
	});
	
})();
