/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.ErrorInCustomEditorWidget"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
	/**
	 * General-purpose widget that can be used to report that there was an error
	 * in a widget that is contributed by a third-party and embedded in our UI,
	 * (eg. custom editors for configuration data or operation behavior).
	 * 
	 * The constructor accepts the following arguments:
	 * 
	 * summaryText	String	Optional. Text that will be displayed above the
	 * 						table of information about the error.
	 * extensionId	String	The identifier of the extension that the contributed
	 * 						widget is providing customization for.
	 * editorTitle	String	Optional. The title of the contributed widget, if
	 * 						there is one.
	 * widgetId		String	The identifier of the contributed widget.
	 * editorError	Error	An exception object that represents the problem
	 * 						that occurred (eg. the error that was thrown by
	 * 						the widget's constructor or an initialization
	 * 						function)
	 */
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.ErrorInCustomEditorWidget", //$NON-NLS-1$
		[dijit._Widget, dijit._Templated], {
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/templates/ErrorInCustomEditorWidget.html"), //$NON-NLS-1$ //$NON-NLS-2$
		constructor: function(arg){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			if (this.summaryText !== undefined) {
				this.summeryTextSpan.appendChild(document.createTextNode(this.summaryText));
			}
			this.idTD.innerHTML = this.extensionId;
			if (this.editorTitle === undefined) {
				dojo.style(this.titleTR, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				this.titleTD.innerHTML = this.editorTitle;	
			}
			this.widgetTD.innerHTML = this.editorWidget;
			this.errorTD.innerHTML = this.editorError;
		}
	});
})();
