/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.OsgiBasedConfigurationDataClient");//$NON-NLS-1$
	dojo.require("jazz.client.xhr"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceRequest"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.TeamServerClient"); //$NON-NLS-1$

	var SERVICE_URI = "com.ibm.team.process.internal.service.web.IProcessWebUIService"; //$NON-NLS-1$
	var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
	var OsgiBasedConfigurationDataClient = com.ibm.team.process.web.ui.internal.admin.projects.OsgiBasedConfigurationDataClient;
	
	/**
	 * Call IProcessWebUIService#getConfigurationData to get configuration data content for the given configuration data ids
	 * @param {Object} args a JSON object passed in to getConfigurationData,
	 *                 {
	 *                  projectAreaUUID:<projectAreaUUID>,
	 *                  configurationDataIds: <an array, each element is a configuration data id>
	 *                 }  
	 * @param {Object} responseHandler
	 */
	function getConfigurationData(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getConfigurationData", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	OsgiBasedConfigurationDataClient.getConfigurationData = getConfigurationData;
	
	/**
	 * Call IProcessWebUIService#getConfigurationDataDeclarations to get all the configuration data declarations
	 * @param {Object} responseHandler
	 */
	function getConfigurationDataDeclarations(responseHandler) {
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getConfigurationDataDeclarations"); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	OsgiBasedConfigurationDataClient.getConfigurationDataDeclarations = getConfigurationDataDeclarations;

})();
