/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	
	/* Wizard Application */
	
	'wizardName': "Server Rename",
	
	/* Status Step */
	
	'boxTitle': "Server Rename Status",
	'renameNotStarted': "The server rename for the Jazz Team Server and its registered applications has not been started. Make sure that the rename operation is in progress and return to this page to track the status.",
	'renameInProgress': "A server rename for the Jazz Team Server and its registered applications has been initiated. None of the applications are accessible until the rename completes successfully.",
	'renameSuccess': "The server rename is successful. The JTS and registered applications are currently in read-only mode. Click \"Next\" to begin the verification process. On the final step of this wizard, you can exit read-only mode and open the server for business.",
	'renameFailure': "The server rename has failed. See the error message(s) below for more detailed information.",
	'exitLinkText': "Go to the Jazz Team Server Home",
	'resetStatus': "Reset Rename Status",
	'success': "Success",
	'error': "Error",
	'errorFetchingStatus': "Unable to determine the status of the server rename. Refresh this page to try again.",
	'renameStatusResetWarning': "Resetting the rename status is for testing purposes only. Please do not do this unless you know what you're doing.",
	'renameStatusReset': "Rename status reset",
	'renameStatusResetError': "Error resetting rename status",
	'errorFetchingApps': "Unable to get a list of registered applications on this Jazz Team Server. Check the server logs.",
	
	/* Verification Step */
	
	'h_label': "Label",
	'h_category': "Category",
	'h_url': "URL",
	'h_flag': "Flag",
	
	'verificationStepTitle': "Verify Application",
	'loading': "Loading URLs for this application...",
	'verificationStepDesc': "Below is a list of important URLs for this application. Verify that these URLs are correct and that the rename was successful. If any of the URLs are incorrect or still need to be renamed, click the flag icon next to the URL to mark it. On the final step of this wizard, all of the flagged URLs will be displayed and suggested actions for correcting the problem will be provided.",
	'flagHover': "Report a problem with this URL.",
	'urlMarked': "You have flagged ${0} URL(s) as having a problem. At the end of this wizard, you will be able to review all problems and address them.",
	'publicUrl': "Public URL",
	'errorFetchingUrls': "CRJAZ2547E An error occurred while fetching the list of URLs for this application. Click \"Next\" to continue verifying URLs on other applications.",
	'noVerificationUrl': "This application does not provide a list of URLs for manual verification. Please click \"Next\" to skip this step.",
	
	/* Summary Step */
	
	'summaryStepTitle': "Summary",
	'flaggedDescription': "A new URL Mapping template has been generated based on the URLs flagged during the verification process. This template can be used to fix URLs that were incorrectly mapped due to typos or missed mappings. If a URL was flagged for another reason, visit the ${0}help documentation${1} for the recommended course of action.",
	'unlockServer': "I have verified the server rename and I am ready to exit read-only mode and open the server for business.",
	'serverUnlockedOK': "The request to complete the server rename and unlock the server completed successfully. Click \"Finish\" to exit this wizard and visit the Jazz Team Server Administration Home page.",
	'unableToUnlock': "CRJAZ2548E An error occurred while attempting to complete the server rename and unlock the sever. View the details below and check the server log.",
	'noneFlaggedDescription': "Congratulations, the server rename was successful. The Jazz Team Server and registered applications are currently in read-only mode. Once you have validated that the data looks correct, check the box below and click \"Finish\". If you have multiple linked CLM deployments, verify each deployment before completing the rename. For more information about verifying the rename operation, see the ${0}help documentation${1}.",
	'renameComplete': "Follow the instructions below to complete the rename.",
	'summaryFailed' :"You have flagged one or more URLs as incorrect. This must be corrected before you complete the rename. Stop the server, create a new mapping file using the template provided below, and run importURLMappings again to perform another rename. See the ${0}help documentation${1} for troubleshooting tips."

})
