/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	
	// template
	
	'heading': "OAuth Consumers",
	'pageDescription' : "Use this page to manage your OAuth consumers or to generate keys for new consumers. An OAuth consumer could be another application, a Jazz Team Server, or a website that is allowed to send requests to this ${0} on behalf of an authorized user. Consumers sign their requests with an authorized consumer key and secret.  For applications registered by the Jazz Team Server setup wizard, consumer keys were generated automatically.  Friend requests from other Jazz Team Servers or applications will generate a consumer key and secret that then require authorization. These requests that require authorization can be found in the Provisional Key section below. The Authorized Key section lists all authorized consumer keys. You are able to view, modify, and remove consumer keys. Trusted consumers will be able to share their authorization with other trusted consumers. Users will not be prompted for approval to access data. Websites and applications external to your organization should be considered untrusted.",
	'pageDescription_jts': "Jazz Team Server",
	'pageDescription_app': "application",
	
	'displayConsumerTableHeading': "Authorized Keys",
	'authorizedKeysDescription': "The following keys are authorized for signing requests to this ${0}. To edit the properties of the consumer key including the name, secret, functional user ID, and trusted setting, select the row you wish to edit and click the \"Edit Consumer\" action from the \"Actions\" column. Associating a pre-authorized functional user with a consumer key allows applications to make requests within background activities such as sending e-mail notifications, without user intervention.",
	'authorizedKeysDescription_jts': "Jazz Team Server",
	'authorizedKeysDescription_app': "application",
	
	'registerConsumerHeading': "Register Consumer",
	'registerConsumerDescription': "Use the form below to generate an authorized OAuth consumer key.",
	'registerButtonText': "Register",
	'consumerKeyLabel': "Consumer Key", 
	'consumerSecretLabel': "Consumer Secret",
	'retypeConsumerSecretLabel': "Re-type Consumer Secret",
	'consumerPublicKeyLabel': "Consumer Public Key",	
	'preAuthorizedUser': "Functional User ID", 
	'selectUserLinkLabel': "Select User...",
	'clearUserLinkLabel': "Clear User...",
	'consumerTrustedLabel': "Trusted", 
	'consumerAuthorized': "Authorized", 
	'untrustedValue': "Untrusted", 
	'trustedValue': "Trusted",
	'authorizedValue': "Authorized",
	
	'consumerKeyGeneratedValue': "The key will be generated by the server",
	'pickConsumerKeyInstead': "Click here to pick the consumer key instead.",
	'generateConsumerKeyInstead': "Click here to let the server generate the consumer key.",
	
	'usePublicKeyInstead': "Click here to use a public key instead.",
	'useSecretInstead': "Click here to use a shared secret instead.",
	
	'editConsumerHeading': "Consumer Key: ${0}",
	'editConsumerDialogTitle': "Edit Consumer Key Properties",
	'confirmEditCancel': "Are you sure you want to exit this editor? Any changes made will be lost. Click Cancel to continue working or OK to exit.",
	
	'fieldNotBlank': "Name cannot be empty",
	'successMessage': "Consumer was registered successfully with Consumer Key: ${0}", 
	'confirmDelete': "Are you sure you want to delete this Consumer Key?",
	'removeConsumerButton': "Delete Consumer Key",
	
	'authorizeProvisionalHeading': "Provisional Keys",
	'authorizeProvisionalDescription': "Friends of this ${0} can request provisional OAuth consumer keys. Requests signed with provisional keys are rejected. Use the form below to authorize any provisional keys so requests from these keys will be accepted.",
	'authorizeProvisionalDescription_jts': "Jazz Team Server",
	'authorizeProvisionalDescription_app': "application",
	
	'noProvisional': "There are no provisional keys.",
	'noConsumer': "There are no consumer keys.",
	'nameLabel': "Consumer Name",
	'provisionalKeyLabel': "Provisional Key",
	'requestedAsLabel': "Requested As",
	'grantAsLabel': "Trusted", 
	'refresh': "Refresh", 
	'save': "Save",
	'pendingLabel': "Pending", 
	'approveLabel': "Approve", 
	'rejectLabel': "Reject",
	'approved': "Approved.",
	'rejected': "Rejected",
	'approvedLabel': "The Provisional Key has been marked as Approved.", 
	'rejectedLabel': "The Provisional Key has been marked as Rejected.",
	
	'actions': "Actions",
	'editConsumer': "Edit Consumer",
	'removeConsumer': "Remove Consumer",
	
	// Help hover text
	'help_consumerSecret': "A \"secret\" or password used by the Consumer to establish ownership of the Consumer Key.",
	'help_trusted': " Trusted consumers will be able to share their authorization with other trusted consumers.",
	'help_functionalId': "Associating a functional user ID with this Consumer Key allows applications to make requests within background activities, such as sending e-mail notifications, without user intervention.",
	
	'trustedWarning': "Are you sure that you want to authorize this key as a trusted consumer?  Trusted consumers will be able to share authorization with other trusted consumers and will not require user approval to access data", 
	
	// Authorize OAuth module
	'moduleHeading': "Authorize Provisional Key",
	'moduleSummary': "You have access on \"${0}\" to authorize the provisional key request from \"${1}\" to establish server-to-server communication.",
	'moduleDetails': "The \"Consumer Name\" can be modified to better identify the requesting server.  Select \"Trusted\" if the requesting consumer should be able to share authorization with other trusted consumers.", 
	'moduleFailure': "CRJAZ1504E There was an error saving updates to the provisional key."	
})
