/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeLanguageDialog"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dojo.io.iframe"); //$NON-NLS-1$
	dojo.require("dojox.uuid"); //$NON-NLS-1$
	dojo.require("dojox.uuid.generateTimeBasedUuid"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.LanguageDialog"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient;
	var LanguageDialog = com.ibm.team.process.authoring.web.common.ui.internal.editors.LanguageDialog;
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeLanguageDialog", [LanguageDialog], { //$NON-NLS-1$
		onOk: function() {
			this.okButton.disabled = true;
			var lang = this.languageSelector.options[this.languageSelector.selectedIndex].value;
			this.workingCopy.currentLanguage = lang;
			this.workingCopy.getTreeJsonArray(this.workingCopy.practiceList[0], dojo.hitch(this, function(treeData) {
				this.controller.displayWaitingMessage(this.messages.PracticeEditor_18);
				this.controller.reload(treeData); //$NON-NLS-1$
				this.dialog.close();
			}), true);
		},
		
		onCreate: function() {
			this.createButton.disabled = true;
			var lang = this.languageSelect.value;
            var langCode = this.getLanguageCode(lang);
			var exist = false;
			dojo.some(this.languageSelector.options, function(op) {
				if (op.value == langCode) {
					exist = true;
					return true;
				}
				return false;
			}, this);
			
			if (exist) {
				alert(this.messages.LanguageDialog_7);
				this.createButton.disabled = false;
			} else {
				ProcessAuthoringClient.createPracticeLanguage({
					'resource': this.resource, //$NON-NLS-1$
					'language': langCode, //$NON-NLS-1$
					'title': this.title, //$NON-NLS-1$
					'description': this.description, //$NON-NLS-1$
					'load': dojo.hitch(this, function(data, ioArgs) { //$NON-NLS-1$
						var ETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
						this.workingCopy.updateLanguagesById(this.itemId, [langCode]);
						var node = this.workingCopy.getNodeById(this.itemId).practice;
						this.workingCopy.setNodeETag(node, langCode, ETag);
						var option = new Option(lang, langCode);
						this.languageSelector.options.add(option);
						this.okButton.disabled = false;
						this.createButton.disabled = false;
					}),
					'error': dojo.hitch(this, function(error) { //$NON-NLS-1$
						var msg;
						if (error.responseText) {
							msg = error.responseText;
						} else {
							msg = error.message;
						}
						this.status.style.visibility = "visible";//$NON-NLS-1$
						dojox.xml.parser.replaceChildren(this.status, document.createTextNode(msg));
						this.status.className = "ErrorStatus";//$NON-NLS-1$
					})
				});
			}
		},
		
		uninitialize: function() {
			this.inherited(arguments);
		}
	});
})();
