/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.dashboard.web.ui.internal.util.WelcomeMsg");

dojo.require("dojo.i18n");
dojo.require("jazz.core.loader");

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

var CREATE_DASHBOARD_WIZARD_CLASS = "com.ibm.team.dashboard.web.ui.internal.wizard.CreateDashboardWizard";

/*
 * A widget that shows a welcome message for the user's first personal dashboard, and a link
 * to replace the dashboard with a templated one. This invokes the create dashboard wizard.
 */
dojo.declare("com.ibm.team.dashboard.web.ui.internal.util.WelcomeMsg",
	[dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/util/WelcomeMsg.html"),
	
	dashboardUrl: null,
	onFinish: function() {},
	
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");
	},
	
	onClick: function(e) {
		dojo.stopEvent(e);
		// lazy load wizard
		jazz.core.loader.load_async(CREATE_DASHBOARD_WIZARD_CLASS, dojo.hitch(this, function() {
			new dojo.getObject(CREATE_DASHBOARD_WIZARD_CLASS)({
				dashboardUrl: this.dashboardUrl,
				onFinish: this.onFinish
			});
		}));
	}
});

})();
