/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.wizard.schema.AboutService");

(function() {

var NAMESPACES = {
	dc: "http://purl.org/dc/terms/",
	jd:	"http://jazz.net/xmlns/prod/jazz/discovery/1.0/",
	jfs: "http://jazz.net/xmlns/foundation/1.0/",
	oslc: "http://open-services.net/ns/core#",
	rdf: "http://www.w3.org/1999/02/22-rdf-syntax-ns#"
};

var Application = {
	namespaces: NAMESPACES,
	publisher: ["string", "oslc:publisher/@rdf:resource", "1"],
	rootServices: ["string", "jd:rootServices/@rdf:resource", "1"],
	contextRoot: ["string", "jd:contextRoot", "1"],
	systemApplication: ["boolean", "jd:systemApplication", "1"]
};

var About = {
	namespaces: NAMESPACES,
	title: ["string", "dc:title", "1"],
	description: ["string", "dc:description", "1"],
	identifier: ["string", "dc:identifier", "1"],
	icon: ["string", "oslc:icon/@rdf:resource", "1"],
	version: ["string", "jfs:version", "1"],
	instanceName: ["string", "jfs:instanceName", "1"],
};

com.ibm.team.repository.web.ui.internal.wizard.schema.AboutService = {
	
	application: {
		namespaces: NAMESPACES,
		Application: [Application, "jd:Application", "1"]
	},
	
	//TODO: Include the oslc:publisher URL for the application-about in this object
	
	aboutService: {
		namespaces: NAMESPACES,
		About: [About, "oslc:Publisher", "1"]
	}
}

})();
