/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
(function() {
	dojo.provide("com.ibm.team.process.web.ui.operationbehavior.UnimplementedOperationBehaviorEditor"); //$NON-NLS-1$
	
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.operationbehavior.AbstractOperationBehaviorCustomEditor"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.operationbehavior", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	/**
	 * Declare this "editor" for preconditions and follow-up actions which
	 * require additional custom configuration, but for which the real custom
	 * editor has not been written yet. It will display a message to let the
	 * user know that they aren't seeing everything and that they should use
	 * the Eclipse client.
	 */
	dojo.declare("com.ibm.team.process.web.ui.operationbehavior.UnimplementedOperationBehaviorEditor", //$NON-NLS-1$
			[com.ibm.team.process.web.ui.operationbehavior.AbstractOperationBehaviorCustomEditor, dijit._Templated], {
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/operationbehavior/templates/UnimplementedOperationBehaviorEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
		
		constructor: function(args) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.operationbehavior", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		initialize: function(content, operationBehaviorId) {
			this._content = content;
			var message = this.messages.UnimplementedOperationBehaviorEditor_0;
			var precondition = "<precondition"; //$NON-NLS-1$
			var followup = "<followup-action"; //$NON-NLS-1$
			if (content && content.slice(0, precondition.length) === precondition) {
				message = this.messages.UnimplementedOperationBehaviorEditor_1;
			} else if (content && content.slice(0, followup.length) === followup) {
				message = this.messages.UnimplementedOperationBehaviorEditor_2;
			}
			this.messageArea.innerHTML = message;
		},
		
		getContent: function() {
			return this._content;
		}
		
	});
})();
